diff --git a/data/bash-completion/fwupdmgr.in b/data/bash-completion/fwupdmgr.in
index f936318601..cfcc0ca5d9 100644
--- a/data/bash-completion/fwupdmgr.in
+++ b/data/bash-completion/fwupdmgr.in
@@ -18,6 +18,7 @@ _fwupdmgr_cmd_list=(
 	'get-topology'
 	'get-updates'
 	'get-upgrades'
+	'get-plugins'
 	'install'
 	'modify-config'
 	'modify-remote'
diff --git a/docs/fwupd-docs.xml b/docs/fwupd-docs.xml
index 42b6637f55..15f6b4a353 100644
--- a/docs/fwupd-docs.xml
+++ b/docs/fwupd-docs.xml
@@ -29,6 +29,7 @@
     <xi:include href="xml/fwupd-client-sync.xml"/>
     <xi:include href="xml/fwupd-device.xml"/>
     <xi:include href="xml/fwupd-release.xml"/>
+    <xi:include href="xml/fwupd-plugin.xml"/>
     <xi:include href="xml/fwupd-remote.xml"/>
     <xi:include href="xml/fwupd-error.xml"/>
     <xi:include href="xml/fwupd-enums.xml"/>
diff --git a/libfwupd/fwupd-client-sync.c b/libfwupd/fwupd-client-sync.c
index e122b376b2..cb6b3c23b7 100644
--- a/libfwupd/fwupd-client-sync.c
+++ b/libfwupd/fwupd-client-sync.c
@@ -146,6 +146,51 @@ fwupd_client_get_devices (FwupdClient *self, GCancellable *cancellable, GError *
 	}
 	return g_steal_pointer (&helper->array);
 }
+
+static void
+fwupd_client_get_plugins_cb (GObject *source, GAsyncResult *res, gpointer user_data)
+{
+	FwupdClientHelper *helper = (FwupdClientHelper *) user_data;
+	helper->array = fwupd_client_get_plugins_finish (FWUPD_CLIENT (source), res, &helper->error);
+	g_main_loop_quit (helper->loop);
+}
+
+/**
+ * fwupd_client_get_plugins:
+ * @self: A #FwupdClient
+ * @cancellable: the #GCancellable, or %NULL
+ * @error: the #GError, or %NULL
+ *
+ * Gets all the plugins being used the daemon.
+ *
+ * Returns: (element-type FwupdPlugin) (transfer container): results
+ *
+ * Since: 1.5.0
+ **/
+GPtrArray *
+fwupd_client_get_plugins (FwupdClient *self, GCancellable *cancellable, GError **error)
+{
+	g_autoptr(FwupdClientHelper) helper = fwupd_client_helper_new ();
+
+	g_return_val_if_fail (FWUPD_IS_CLIENT (self), NULL);
+	g_return_val_if_fail (cancellable == NULL || G_IS_CANCELLABLE (cancellable), NULL);
+	g_return_val_if_fail (error == NULL || *error == NULL, NULL);
+
+	/* connect */
+	if (!fwupd_client_connect (self, cancellable, error))
+		return NULL;
+
+	/* call async version and run loop until complete */
+	fwupd_client_get_plugins_async (self, cancellable,
+					fwupd_client_get_plugins_cb, helper);
+	g_main_loop_run (helper->loop);
+	if (helper->array == NULL) {
+		g_propagate_error (error, g_steal_pointer (&helper->error));
+		return NULL;
+	}
+	return g_steal_pointer (&helper->array);
+}
+
 static void
 fwupd_client_get_history_cb (GObject *source, GAsyncResult *res, gpointer user_data)
 {
diff --git a/libfwupd/fwupd-client-sync.h b/libfwupd/fwupd-client-sync.h
index 947ddab05c..974b5a44f8 100644
--- a/libfwupd/fwupd-client-sync.h
+++ b/libfwupd/fwupd-client-sync.h
@@ -14,6 +14,9 @@ gboolean	 fwupd_client_connect			(FwupdClient	*self,
 GPtrArray	*fwupd_client_get_devices		(FwupdClient	*self,
 							 GCancellable	*cancellable,
 							 GError		**error);
+GPtrArray	*fwupd_client_get_plugins		(FwupdClient	*self,
+							 GCancellable	*cancellable,
+							 GError		**error);
 GPtrArray	*fwupd_client_get_history		(FwupdClient	*self,
 							 GCancellable	*cancellable,
 							 GError		**error);
diff --git a/libfwupd/fwupd-client.c b/libfwupd/fwupd-client.c
index c8a1aed5e3..7690316658 100644
--- a/libfwupd/fwupd-client.c
+++ b/libfwupd/fwupd-client.c
@@ -25,6 +25,7 @@
 #include "fwupd-enums.h"
 #include "fwupd-error.h"
 #include "fwupd-device-private.h"
+#include "fwupd-plugin-private.h"
 #include "fwupd-security-attr-private.h"
 #include "fwupd-release-private.h"
 #include "fwupd-remote-private.h"
@@ -746,6 +747,83 @@ fwupd_client_get_devices_finish (FwupdClient *self, GAsyncResult *res, GError **
 	return g_task_propagate_pointer (G_TASK(res), error);
 }
 
+static void
+fwupd_client_get_plugins_cb (GObject *source,
+			     GAsyncResult *res,
+			     gpointer user_data)
+{
+	g_autoptr(GTask) task = G_TASK (user_data);
+	g_autoptr(GError) error = NULL;
+	g_autoptr(GVariant) val = NULL;
+
+	val = g_dbus_proxy_call_finish (G_DBUS_PROXY (source), res, &error);
+	if (val == NULL) {
+		fwupd_client_fixup_dbus_error (error);
+		g_task_return_error (task, g_steal_pointer (&error));
+		return;
+	}
+
+	/* success */
+	g_task_return_pointer (task,
+			       fwupd_plugin_array_from_variant (val),
+			       (GDestroyNotify) g_ptr_array_unref);
+}
+
+/**
+ * fwupd_client_get_plugins_async:
+ * @self: A #FwupdClient
+ * @cancellable: the #GCancellable, or %NULL
+ * @callback: the function to run on completion
+ * @callback_data: the data to pass to @callback
+ *
+ * Gets all the plugins being used by the daemon.
+ *
+ * You must have called fwupd_client_connect_async() on @self before using
+ * this method.
+ *
+ * Since: 1.5.0
+ **/
+void
+fwupd_client_get_plugins_async (FwupdClient *self, GCancellable *cancellable,
+				GAsyncReadyCallback callback, gpointer callback_data)
+{
+	FwupdClientPrivate *priv = GET_PRIVATE (self);
+	g_autoptr(GTask) task = NULL;
+
+	g_return_if_fail (FWUPD_IS_CLIENT (self));
+	g_return_if_fail (cancellable == NULL || G_IS_CANCELLABLE (cancellable));
+	g_return_if_fail (priv->proxy != NULL);
+
+	/* call into daemon */
+	task = g_task_new (self, cancellable, callback, callback_data);
+	g_dbus_proxy_call (priv->proxy, "GetPlugins",
+			   NULL, G_DBUS_CALL_FLAGS_NONE,
+			   -1, cancellable,
+			   fwupd_client_get_plugins_cb,
+			   g_steal_pointer (&task));
+}
+
+/**
+ * fwupd_client_get_plugins_finish:
+ * @self: A #FwupdClient
+ * @res: the #GAsyncResult
+ * @error: the #GError, or %NULL
+ *
+ * Gets the result of fwupd_client_get_plugins_async().
+ *
+ * Returns: (element-type FwupdDevice) (transfer container): results
+ *
+ * Since: 1.5.0
+ **/
+GPtrArray *
+fwupd_client_get_plugins_finish (FwupdClient *self, GAsyncResult *res, GError **error)
+{
+	g_return_val_if_fail (FWUPD_IS_CLIENT (self), NULL);
+	g_return_val_if_fail (g_task_is_valid (res, self), NULL);
+	g_return_val_if_fail (error == NULL || *error == NULL, NULL);
+	return g_task_propagate_pointer (G_TASK(res), error);
+}
+
 static void
 fwupd_client_get_history_cb (GObject *source,
 			     GAsyncResult *res,
diff --git a/libfwupd/fwupd-client.h b/libfwupd/fwupd-client.h
index ea3eeadb47..6899df329c 100644
--- a/libfwupd/fwupd-client.h
+++ b/libfwupd/fwupd-client.h
@@ -11,6 +11,7 @@
 
 #include "fwupd-enums.h"
 #include "fwupd-device.h"
+#include "fwupd-plugin.h"
 #include "fwupd-remote.h"
 
 G_BEGIN_DECLS
@@ -81,6 +82,13 @@ void		 fwupd_client_get_devices_async		(FwupdClient	*self,
 GPtrArray	*fwupd_client_get_devices_finish	(FwupdClient	*self,
 							 GAsyncResult	*res,
 							 GError		**error);
+void		 fwupd_client_get_plugins_async		(FwupdClient	*self,
+							 GCancellable	*cancellable,
+							 GAsyncReadyCallback callback,
+							 gpointer	 callback_data);
+GPtrArray	*fwupd_client_get_plugins_finish	(FwupdClient	*self,
+							 GAsyncResult	*res,
+							 GError		**error);
 void		 fwupd_client_get_history_async		(FwupdClient	*self,
 							 GCancellable	*cancellable,
 							 GAsyncReadyCallback callback,
diff --git a/libfwupd/fwupd-enums-private.h b/libfwupd/fwupd-enums-private.h
index deaf86f1d2..7176d2d89d 100644
--- a/libfwupd/fwupd-enums-private.h
+++ b/libfwupd/fwupd-enums-private.h
@@ -6,6 +6,8 @@
 
 #pragma once
 
+#include <glib.h>
+
 G_BEGIN_DECLS
 
 #define FWUPD_RESULT_KEY_APPSTREAM_ID		"AppstreamId"	/* s */
diff --git a/libfwupd/fwupd-enums.c b/libfwupd/fwupd-enums.c
index a35cf31e79..f3b1fae294 100644
--- a/libfwupd/fwupd-enums.c
+++ b/libfwupd/fwupd-enums.c
@@ -306,6 +306,80 @@ fwupd_device_flag_from_string (const gchar *device_flag)
 	return FWUPD_DEVICE_FLAG_UNKNOWN;
 }
 
+/**
+ * fwupd_plugin_flag_to_string:
+ * @plugin_flag: A #FwupdPluginFlags, e.g. %FWUPD_DEVICE_FLAG_REQUIRE_AC
+ *
+ * Converts a #FwupdDeviceFlags to a string.
+ *
+ * Return value: identifier string
+ *
+ * Since: 1.5.0
+ **/
+const gchar *
+fwupd_plugin_flag_to_string (FwupdPluginFlags plugin_flag)
+{
+	if (plugin_flag == FWUPD_DEVICE_FLAG_NONE)
+		return "none";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_DISABLED)
+		return "disabled";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_USER_WARNING)
+		return "user-warning";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE)
+		return "clear-updatable";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_NO_HARDWARE)
+		return "no-hardware";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED)
+		return "capsules-unsupported";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED)
+		return "unlock-required";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED)
+		return "efivar-not-mounted";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND)
+		return "esp-not-found";
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_LEGACY_BIOS)
+		return "legacy-bios";
+	if (plugin_flag == FWUPD_DEVICE_FLAG_UNKNOWN)
+		return "unknown";
+	return NULL;
+}
+
+/**
+ * fwupd_plugin_flag_from_string:
+ * @plugin_flag: A string, e.g. `require-ac`
+ *
+ * Converts a string to a #FwupdPluginFlags.
+ *
+ * Return value: enumerated value
+ *
+ * Since: 1.5.0
+ **/
+FwupdPluginFlags
+fwupd_plugin_flag_from_string (const gchar *plugin_flag)
+{
+	if (g_strcmp0 (plugin_flag, "none") == 0)
+		return FWUPD_DEVICE_FLAG_NONE;
+	if (g_strcmp0 (plugin_flag, "disabled") == 0)
+		return FWUPD_PLUGIN_FLAG_DISABLED;
+	if (g_strcmp0 (plugin_flag, "user-warning") == 0)
+		return FWUPD_PLUGIN_FLAG_USER_WARNING;
+	if (g_strcmp0 (plugin_flag, "clear-updatable") == 0)
+		return FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE;
+	if (g_strcmp0 (plugin_flag, "no-hardware") == 0)
+		return FWUPD_PLUGIN_FLAG_NO_HARDWARE;
+	if (g_strcmp0 (plugin_flag, "capsules-unsupported") == 0)
+		return FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED;
+	if (g_strcmp0 (plugin_flag, "unlock-required") == 0)
+		return FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED;
+	if (g_strcmp0 (plugin_flag, "efivar-not-mounted") == 0)
+		return FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED;
+	if (g_strcmp0 (plugin_flag, "esp-not-found") == 0)
+		return FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND;
+	if (g_strcmp0 (plugin_flag, "legacy-bios") == 0)
+		return FWUPD_PLUGIN_FLAG_LEGACY_BIOS;
+	return FWUPD_DEVICE_FLAG_UNKNOWN;
+}
+
 /**
  * fwupd_update_state_to_string:
  * @update_state: A #FwupdUpdateState, e.g. %FWUPD_UPDATE_STATE_PENDING
diff --git a/libfwupd/fwupd-enums.h b/libfwupd/fwupd-enums.h
index 5bc9f6eee4..6d8143e3e7 100644
--- a/libfwupd/fwupd-enums.h
+++ b/libfwupd/fwupd-enums.h
@@ -220,6 +220,34 @@ typedef enum {
 	FWUPD_RELEASE_URGENCY_LAST
 } FwupdReleaseUrgency;
 
+/**
+ * FwupdPluginFlags:
+ * @FWUPD_PLUGIN_FLAG_NONE:			No flags set
+ * @FWUPD_PLUGIN_FLAG_DISABLED:			Disabled
+ * @FWUPD_PLUGIN_FLAG_USER_WARNING:		Show the user a warning
+ * @FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE:		Clear the UPDATABLE flag from devices
+ * @FWUPD_PLUGIN_FLAG_NO_HARDWARE:		No hardware is found
+ * @FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED:	UEFI UpdateCapsule are unsupported
+ * @FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED:		Hardware unlock is required
+ * @FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED:	The efivar filesystem is not found
+ * @FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND:		The EFI ESP not found
+ * @FWUPD_PLUGIN_FLAG_LEGACY_BIOS:		System running in legacy CSM mode
+ *
+ * The plugin flags.
+ **/
+#define FWUPD_PLUGIN_FLAG_NONE			(0u)		/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_DISABLED		(1u << 0)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_USER_WARNING		(1u << 1)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE	(1u << 2)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_NO_HARDWARE		(1u << 3)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED	(1u << 4)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED	(1u << 5)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED	(1u << 6)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND		(1u << 7)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_LEGACY_BIOS		(1u << 8)	/* Since: 1.5.0 */
+#define FWUPD_PLUGIN_FLAG_UNKNOWN		G_MAXUINT64	/* Since: 1.5.0 */
+typedef guint64 FwupdPluginFlags;
+
 /**
  * FwupdInstallFlags:
  * @FWUPD_INSTALL_FLAG_NONE:			No flags set
@@ -351,6 +379,8 @@ const gchar	*fwupd_status_to_string			(FwupdStatus	 status);
 FwupdStatus	 fwupd_status_from_string		(const gchar	*status);
 const gchar	*fwupd_device_flag_to_string		(FwupdDeviceFlags device_flag);
 FwupdDeviceFlags fwupd_device_flag_from_string		(const gchar	*device_flag);
+const gchar	*fwupd_plugin_flag_to_string		(FwupdPluginFlags plugin_flag);
+FwupdPluginFlags fwupd_plugin_flag_from_string		(const gchar	*plugin_flag);
 const gchar	*fwupd_release_flag_to_string		(FwupdReleaseFlags release_flag);
 FwupdReleaseFlags fwupd_release_flag_from_string	(const gchar	*release_flag);
 const gchar	*fwupd_release_urgency_to_string	(FwupdReleaseUrgency release_urgency);
diff --git a/libfwupd/fwupd-plugin-private.h b/libfwupd/fwupd-plugin-private.h
new file mode 100644
index 0000000000..8902ada434
--- /dev/null
+++ b/libfwupd/fwupd-plugin-private.h
@@ -0,0 +1,20 @@
+/*
+ * Copyright (C) 2020 Richard Hughes <richard@hughsie.com>
+ *
+ * SPDX-License-Identifier: LGPL-2.1+
+ */
+
+#pragma once
+
+#include <json-glib/json-glib.h>
+
+#include "fwupd-plugin.h"
+
+G_BEGIN_DECLS
+
+GVariant	*fwupd_plugin_to_variant		(FwupdPlugin	*plugin);
+void		 fwupd_plugin_to_json			(FwupdPlugin	*plugin,
+							 JsonBuilder	*builder);
+
+G_END_DECLS
+
diff --git a/libfwupd/fwupd-plugin.c b/libfwupd/fwupd-plugin.c
new file mode 100644
index 0000000000..e278205217
--- /dev/null
+++ b/libfwupd/fwupd-plugin.c
@@ -0,0 +1,484 @@
+/*
+ * Copyright (C) 2020 Richard Hughes <richard@hughsie.com>
+ *
+ * SPDX-License-Identifier: LGPL-2.1+
+ */
+
+#include "config.h"
+
+#include "fwupd-enums-private.h"
+#include "fwupd-plugin-private.h"
+
+/**
+ * SECTION:fwupd-plugin
+ * @short_description: a hardware plugin
+ *
+ * An object that represents a fwupd plugin.
+ *
+ * See also: #FwupdRelease
+ */
+
+static void fwupd_plugin_finalize	 (GObject *object);
+
+typedef struct {
+	gchar				*name;
+	guint64				 flags;
+} FwupdPluginPrivate;
+
+enum {
+	PROP_0,
+	PROP_NAME,
+	PROP_FLAGS,
+	PROP_LAST
+};
+
+G_DEFINE_TYPE_WITH_PRIVATE (FwupdPlugin, fwupd_plugin, G_TYPE_OBJECT)
+#define GET_PRIVATE(o) (fwupd_plugin_get_instance_private (o))
+
+/**
+ * fwupd_plugin_get_name:
+ * @plugin: A #FwupdPlugin
+ *
+ * Gets the plugin name.
+ *
+ * Returns: the plugin name, or %NULL if unset
+ *
+ * Since: 1.5.0
+ **/
+const gchar *
+fwupd_plugin_get_name (FwupdPlugin *plugin)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_val_if_fail (FWUPD_IS_PLUGIN (plugin), NULL);
+	return priv->name;
+}
+
+/**
+ * fwupd_plugin_set_name:
+ * @plugin: A #FwupdPlugin
+ * @name: the plugin name, e.g. `bios`
+ *
+ * Sets the plugin name.
+ *
+ * Since: 1.5.0
+ **/
+void
+fwupd_plugin_set_name (FwupdPlugin *plugin, const gchar *name)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_if_fail (FWUPD_IS_PLUGIN (plugin));
+	g_return_if_fail (name != NULL);
+	g_free (priv->name);
+	priv->name = g_strdup (name);
+	g_object_notify (G_OBJECT (plugin), "name");
+}
+
+/**
+ * fwupd_plugin_get_flags:
+ * @plugin: A #FwupdPlugin
+ *
+ * Gets the plugin flags.
+ *
+ * Returns: the plugin flags, or 0 if unset
+ *
+ * Since: 1.5.0
+ **/
+guint64
+fwupd_plugin_get_flags (FwupdPlugin *plugin)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_val_if_fail (FWUPD_IS_PLUGIN (plugin), 0);
+	return priv->flags;
+}
+
+/**
+ * fwupd_plugin_set_flags:
+ * @plugin: A #FwupdPlugin
+ * @flags: the plugin flags, e.g. %FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED
+ *
+ * Sets the plugin flags.
+ *
+ * Since: 1.5.0
+ **/
+void
+fwupd_plugin_set_flags (FwupdPlugin *plugin, guint64 flags)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_if_fail (FWUPD_IS_PLUGIN (plugin));
+	if (priv->flags == flags)
+		return;
+	priv->flags = flags;
+	g_object_notify (G_OBJECT (plugin), "flags");
+}
+
+/**
+ * fwupd_plugin_add_flag:
+ * @plugin: A #FwupdPlugin
+ * @flag: the #FwupdPluginFlags
+ *
+ * Adds a specific plugin flag to the plugin.
+ *
+ * Since: 1.5.0
+ **/
+void
+fwupd_plugin_add_flag (FwupdPlugin *plugin, FwupdPluginFlags flag)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_if_fail (FWUPD_IS_PLUGIN (plugin));
+	if (flag == 0)
+		return;
+	if ((priv->flags & flag) > 0)
+		return;
+	priv->flags |= flag;
+	g_object_notify (G_OBJECT (plugin), "flags");
+}
+
+/**
+ * fwupd_plugin_remove_flag:
+ * @plugin: A #FwupdPlugin
+ * @flag: the #FwupdPluginFlags
+ *
+ * Removes a specific plugin flag from the plugin.
+ *
+ * Since: 1.5.0
+ **/
+void
+fwupd_plugin_remove_flag (FwupdPlugin *plugin, FwupdPluginFlags flag)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_if_fail (FWUPD_IS_PLUGIN (plugin));
+	if (flag == 0)
+		return;
+	if ((priv->flags & flag) == 0)
+		return;
+	priv->flags &= ~flag;
+	g_object_notify (G_OBJECT (plugin), "flags");
+}
+
+/**
+ * fwupd_plugin_has_flag:
+ * @plugin: A #FwupdPlugin
+ * @flag: the #FwupdPluginFlags
+ *
+ * Finds if the plugin has a specific plugin flag.
+ *
+ * Returns: %TRUE if the flag is set
+ *
+ * Since: 1.5.0
+ **/
+gboolean
+fwupd_plugin_has_flag (FwupdPlugin *plugin, FwupdPluginFlags flag)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_return_val_if_fail (FWUPD_IS_PLUGIN (plugin), FALSE);
+	return (priv->flags & flag) > 0;
+}
+
+/**
+ * fwupd_plugin_to_variant:
+ * @plugin: A #FwupdPlugin
+ *
+ * Creates a GVariant from the plugin data omitting sensitive fields
+ *
+ * Returns: the GVariant, or %NULL for error
+ *
+ * Since: 1.5.0
+ **/
+GVariant *
+fwupd_plugin_to_variant (FwupdPlugin *plugin)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	GVariantBuilder builder;
+
+	g_return_val_if_fail (FWUPD_IS_PLUGIN (plugin), NULL);
+
+	/* create an array with all the metadata in */
+	g_variant_builder_init (&builder, G_VARIANT_TYPE_VARDICT);
+	if (priv->name != NULL) {
+		g_variant_builder_add (&builder, "{sv}",
+				       FWUPD_RESULT_KEY_NAME,
+				       g_variant_new_string (priv->name));
+	}
+	if (priv->flags > 0) {
+		g_variant_builder_add (&builder, "{sv}",
+				       FWUPD_RESULT_KEY_FLAGS,
+				       g_variant_new_uint64 (priv->flags));
+	}
+	return g_variant_new ("a{sv}", &builder);
+}
+
+static void
+fwupd_plugin_from_key_value (FwupdPlugin *plugin, const gchar *key, GVariant *value)
+{
+	if (g_strcmp0 (key, FWUPD_RESULT_KEY_NAME) == 0) {
+		fwupd_plugin_set_name (plugin, g_variant_get_string (value, NULL));
+		return;
+	}
+	if (g_strcmp0 (key, FWUPD_RESULT_KEY_FLAGS) == 0) {
+		fwupd_plugin_set_flags (plugin, g_variant_get_uint64 (value));
+		return;
+	}
+}
+
+static void
+fwupd_pad_kv_str (GString *str, const gchar *key, const gchar *value)
+{
+	/* ignore */
+	if (key == NULL || value == NULL)
+		return;
+	g_string_append_printf (str, "  %s: ", key);
+	for (gsize i = strlen (key); i < 20; i++)
+		g_string_append (str, " ");
+	g_string_append_printf (str, "%s\n", value);
+}
+
+static void
+fwupd_pad_kv_dfl (GString *str, const gchar *key, guint64 plugin_flags)
+{
+	g_autoptr(GString) tmp = g_string_new ("");
+	for (guint i = 0; i < 64; i++) {
+		if ((plugin_flags & ((guint64) 1 << i)) == 0)
+			continue;
+		g_string_append_printf (tmp, "%s|",
+					fwupd_plugin_flag_to_string ((guint64) 1 << i));
+	}
+	if (tmp->len == 0) {
+		g_string_append (tmp, fwupd_plugin_flag_to_string (0));
+	} else {
+		g_string_truncate (tmp, tmp->len - 1);
+	}
+	fwupd_pad_kv_str (str, key, tmp->str);
+}
+
+static void
+fwupd_plugin_json_add_string (JsonBuilder *builder, const gchar *key, const gchar *str)
+{
+	if (str == NULL)
+		return;
+	json_builder_set_member_name (builder, key);
+	json_builder_add_string_value (builder, str);
+}
+
+/**
+ * fwupd_plugin_to_json:
+ * @plugin: A #FwupdPlugin
+ * @builder: A #JsonBuilder
+ *
+ * Adds a fwupd plugin to a JSON builder
+ *
+ * Since: 1.5.0
+ **/
+void
+fwupd_plugin_to_json (FwupdPlugin *plugin, JsonBuilder *builder)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+
+	g_return_if_fail (FWUPD_IS_PLUGIN (plugin));
+	g_return_if_fail (builder != NULL);
+
+	fwupd_plugin_json_add_string (builder, FWUPD_RESULT_KEY_NAME, priv->name);
+	if (priv->flags != FWUPD_PLUGIN_FLAG_NONE) {
+		json_builder_set_member_name (builder, FWUPD_RESULT_KEY_FLAGS);
+		json_builder_begin_array (builder);
+		for (guint i = 0; i < 64; i++) {
+			const gchar *tmp;
+			if ((priv->flags & ((guint64) 1 << i)) == 0)
+				continue;
+			tmp = fwupd_plugin_flag_to_string ((guint64) 1 << i);
+			json_builder_add_string_value (builder, tmp);
+		}
+		json_builder_end_array (builder);
+	}
+}
+
+/**
+ * fwupd_plugin_to_string:
+ * @plugin: A #FwupdPlugin
+ *
+ * Builds a text representation of the object.
+ *
+ * Returns: text, or %NULL for invalid
+ *
+ * Since: 1.5.0
+ **/
+gchar *
+fwupd_plugin_to_string (FwupdPlugin *plugin)
+{
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	GString *str;
+
+	g_return_val_if_fail (FWUPD_IS_PLUGIN (plugin), NULL);
+
+	str = g_string_new (NULL);
+	fwupd_pad_kv_str (str, FWUPD_RESULT_KEY_NAME, priv->name);
+	fwupd_pad_kv_dfl (str, FWUPD_RESULT_KEY_FLAGS, priv->flags);
+	return g_string_free (str, FALSE);
+}
+
+static void
+fwupd_plugin_get_property (GObject *object, guint prop_id,
+			   GValue *value, GParamSpec *pspec)
+{
+	FwupdPlugin *self = FWUPD_PLUGIN (object);
+	FwupdPluginPrivate *priv = GET_PRIVATE (self);
+	switch (prop_id) {
+	case PROP_NAME:
+		g_value_set_string (value, priv->name);
+		break;
+	case PROP_FLAGS:
+		g_value_set_uint64 (value, priv->flags);
+		break;
+	default:
+		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+		break;
+	}
+}
+
+static void
+fwupd_plugin_set_property (GObject *object, guint prop_id,
+			   const GValue *value, GParamSpec *pspec)
+{
+	FwupdPlugin *self = FWUPD_PLUGIN (object);
+	switch (prop_id) {
+	case PROP_NAME:
+		fwupd_plugin_set_name (self, g_value_get_string (value));
+		break;
+	case PROP_FLAGS:
+		fwupd_plugin_set_flags (self, g_value_get_uint64 (value));
+		break;
+	default:
+		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+		break;
+	}
+}
+
+static void
+fwupd_plugin_class_init (FwupdPluginClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+	GParamSpec *pspec;
+
+	object_class->finalize = fwupd_plugin_finalize;
+	object_class->get_property = fwupd_plugin_get_property;
+	object_class->set_property = fwupd_plugin_set_property;
+
+	pspec = g_param_spec_string ("name", NULL, NULL, NULL,
+				     G_PARAM_READWRITE |
+				     G_PARAM_STATIC_NAME);
+	g_object_class_install_property (object_class, PROP_NAME, pspec);
+
+	pspec = g_param_spec_uint64 ("flags", NULL, NULL,
+				     FWUPD_PLUGIN_FLAG_NONE,
+				     FWUPD_PLUGIN_FLAG_UNKNOWN,
+				     FWUPD_PLUGIN_FLAG_NONE,
+				     G_PARAM_READWRITE |
+				     G_PARAM_STATIC_NAME);
+	g_object_class_install_property (object_class, PROP_FLAGS, pspec);
+}
+
+static void
+fwupd_plugin_init (FwupdPlugin *plugin)
+{
+}
+
+static void
+fwupd_plugin_finalize (GObject *object)
+{
+	FwupdPlugin *plugin = FWUPD_PLUGIN (object);
+	FwupdPluginPrivate *priv = GET_PRIVATE (plugin);
+	g_free (priv->name);
+	G_OBJECT_CLASS (fwupd_plugin_parent_class)->finalize (object);
+}
+
+static void
+fwupd_plugin_set_from_variant_iter (FwupdPlugin *plugin, GVariantIter *iter)
+{
+	GVariant *value;
+	const gchar *key;
+	while (g_variant_iter_next (iter, "{&sv}", &key, &value)) {
+		fwupd_plugin_from_key_value (plugin, key, value);
+		g_variant_unref (value);
+	}
+}
+
+/**
+ * fwupd_plugin_from_variant:
+ * @value: a #GVariant
+ *
+ * Creates a new plugin using packed data.
+ *
+ * Returns: (transfer full): a new #FwupdPlugin, or %NULL if @value was invalid
+ *
+ * Since: 1.5.0
+ **/
+FwupdPlugin *
+fwupd_plugin_from_variant (GVariant *value)
+{
+	FwupdPlugin *plugin = NULL;
+	const gchar *type_string;
+	g_autoptr(GVariantIter) iter = NULL;
+
+	/* format from GetDetails */
+	type_string = g_variant_get_type_string (value);
+	if (g_strcmp0 (type_string, "(a{sv})") == 0) {
+		plugin = fwupd_plugin_new ();
+		g_variant_get (value, "(a{sv})", &iter);
+		fwupd_plugin_set_from_variant_iter (plugin, iter);
+	} else if (g_strcmp0 (type_string, "a{sv}") == 0) {
+		plugin = fwupd_plugin_new ();
+		g_variant_get (value, "a{sv}", &iter);
+		fwupd_plugin_set_from_variant_iter (plugin, iter);
+	} else {
+		g_warning ("type %s not known", type_string);
+	}
+	return plugin;
+}
+
+/**
+ * fwupd_plugin_array_from_variant:
+ * @value: a #GVariant
+ *
+ * Creates an array of new plugins using packed data.
+ *
+ * Returns: (transfer container) (element-type FwupdPlugin): plugins, or %NULL if @value was invalid
+ *
+ * Since: 1.5.0
+ **/
+GPtrArray *
+fwupd_plugin_array_from_variant (GVariant *value)
+{
+	GPtrArray *array = NULL;
+	gsize sz;
+	g_autoptr(GVariant) untuple = NULL;
+
+	array = g_ptr_array_new_with_free_func ((GDestroyNotify) g_object_unref);
+	untuple = g_variant_get_child_value (value, 0);
+	sz = g_variant_n_children (untuple);
+	for (guint i = 0; i < sz; i++) {
+		FwupdPlugin *plugin;
+		g_autoptr(GVariant) data = NULL;
+		data = g_variant_get_child_value (untuple, i);
+		plugin = fwupd_plugin_from_variant (data);
+		if (plugin == NULL)
+			continue;
+		g_ptr_array_add (array, plugin);
+	}
+	return array;
+}
+
+/**
+ * fwupd_plugin_new:
+ *
+ * Creates a new plugin.
+ *
+ * Returns: a new #FwupdPlugin
+ *
+ * Since: 1.5.0
+ **/
+FwupdPlugin *
+fwupd_plugin_new (void)
+{
+	FwupdPlugin *plugin;
+	plugin = g_object_new (FWUPD_TYPE_PLUGIN, NULL);
+	return FWUPD_PLUGIN (plugin);
+}
diff --git a/libfwupd/fwupd-plugin.h b/libfwupd/fwupd-plugin.h
new file mode 100644
index 0000000000..5d7cfaf12c
--- /dev/null
+++ b/libfwupd/fwupd-plugin.h
@@ -0,0 +1,50 @@
+/*
+ * Copyright (C) 2020 Richard Hughes <richard@hughsie.com>
+ *
+ * SPDX-License-Identifier: LGPL-2.1+
+ */
+
+#pragma once
+
+#include <glib-object.h>
+
+#include "fwupd-enums.h"
+
+G_BEGIN_DECLS
+
+#define FWUPD_TYPE_PLUGIN (fwupd_plugin_get_type ())
+G_DECLARE_DERIVABLE_TYPE (FwupdPlugin, fwupd_plugin, FWUPD, PLUGIN, GObject)
+
+struct _FwupdPluginClass
+{
+	GObjectClass			 parent_class;
+	/*< private >*/
+	void (*_fwupd_reserved1)	(void);
+	void (*_fwupd_reserved2)	(void);
+	void (*_fwupd_reserved3)	(void);
+	void (*_fwupd_reserved4)	(void);
+	void (*_fwupd_reserved5)	(void);
+	void (*_fwupd_reserved6)	(void);
+	void (*_fwupd_reserved7)	(void);
+};
+
+FwupdPlugin	*fwupd_plugin_new			(void);
+gchar		*fwupd_plugin_to_string			(FwupdPlugin	*plugin);
+
+const gchar	*fwupd_plugin_get_name			(FwupdPlugin	*plugin);
+void		 fwupd_plugin_set_name			(FwupdPlugin	*plugin,
+							 const gchar	*name);
+guint64		 fwupd_plugin_get_flags			(FwupdPlugin	*plugin);
+void		 fwupd_plugin_set_flags			(FwupdPlugin	*plugin,
+							 guint64	 flags);
+void		 fwupd_plugin_add_flag			(FwupdPlugin	*plugin,
+							 FwupdPluginFlags flag);
+void		 fwupd_plugin_remove_flag		(FwupdPlugin	*plugin,
+							 FwupdPluginFlags flag);
+gboolean	 fwupd_plugin_has_flag			(FwupdPlugin	*plugin,
+							 FwupdPluginFlags flag);
+
+FwupdPlugin	*fwupd_plugin_from_variant		(GVariant	*value);
+GPtrArray	*fwupd_plugin_array_from_variant	(GVariant	*value);
+
+G_END_DECLS
diff --git a/libfwupd/fwupd-self-test.c b/libfwupd/fwupd-self-test.c
index 626c713b0a..62d9b082ed 100644
--- a/libfwupd/fwupd-self-test.c
+++ b/libfwupd/fwupd-self-test.c
@@ -148,6 +148,12 @@ fwupd_enums_func (void)
 			break;
 		g_assert_cmpint (fwupd_device_flag_from_string (tmp), ==, i);
 	}
+	for (guint64 i = 1; i < FWUPD_PLUGIN_FLAG_UNKNOWN; i *= 2) {
+		const gchar *tmp = fwupd_plugin_flag_to_string (i);
+		if (tmp == NULL)
+			break;
+		g_assert_cmpint (fwupd_plugin_flag_from_string (tmp), ==, i);
+	}
 }
 
 static void
diff --git a/libfwupd/fwupd.h b/libfwupd/fwupd.h
index a8bffb347a..a3c020ed9e 100644
--- a/libfwupd/fwupd.h
+++ b/libfwupd/fwupd.h
@@ -17,6 +17,7 @@
 #include <libfwupd/fwupd-client-sync.h>
 #include <libfwupd/fwupd-common.h>
 #include <libfwupd/fwupd-device.h>
+#include <libfwupd/fwupd-plugin.h>
 #include <libfwupd/fwupd-enums.h>
 #include <libfwupd/fwupd-error.h>
 #include <libfwupd/fwupd-security-attr.h>
diff --git a/libfwupd/fwupd.map b/libfwupd/fwupd.map
index 6cce795293..097d967eae 100644
--- a/libfwupd/fwupd.map
+++ b/libfwupd/fwupd.map
@@ -507,6 +507,9 @@ LIBFWUPD_1.5.0 {
     fwupd_client_get_host_security_attrs_async;
     fwupd_client_get_host_security_attrs_finish;
     fwupd_client_get_host_security_id;
+    fwupd_client_get_plugins;
+    fwupd_client_get_plugins_async;
+    fwupd_client_get_plugins_finish;
     fwupd_client_get_releases_async;
     fwupd_client_get_releases_finish;
     fwupd_client_get_remote_by_id_async;
@@ -554,6 +557,22 @@ LIBFWUPD_1.5.0 {
     fwupd_client_verify_update_finish;
     fwupd_device_get_branch;
     fwupd_device_set_branch;
+    fwupd_plugin_add_flag;
+    fwupd_plugin_array_from_variant;
+    fwupd_plugin_flag_from_string;
+    fwupd_plugin_flag_to_string;
+    fwupd_plugin_from_variant;
+    fwupd_plugin_get_flags;
+    fwupd_plugin_get_name;
+    fwupd_plugin_get_type;
+    fwupd_plugin_has_flag;
+    fwupd_plugin_new;
+    fwupd_plugin_remove_flag;
+    fwupd_plugin_set_flags;
+    fwupd_plugin_set_name;
+    fwupd_plugin_to_json;
+    fwupd_plugin_to_string;
+    fwupd_plugin_to_variant;
     fwupd_release_get_branch;
     fwupd_release_set_branch;
     fwupd_remote_get_automatic_security_reports;
diff --git a/libfwupd/meson.build b/libfwupd/meson.build
index 57e35b0daf..4ac6814735 100644
--- a/libfwupd/meson.build
+++ b/libfwupd/meson.build
@@ -24,6 +24,7 @@ install_headers([
     'fwupd-remote.h',
     'fwupd-security-attr.h',
     'fwupd-release.h',
+    'fwupd-plugin.h',
     fwupd_version_h,
   ],
   subdir : 'fwupd-1/libfwupd',
@@ -42,6 +43,7 @@ fwupd = shared_library(
     'fwupd-error.c',
     'fwupd-security-attr.c',
     'fwupd-release.c',
+    'fwupd-plugin.c',
     'fwupd-remote.c',
   ],
   soversion : libfwupd_lt_current,
@@ -97,6 +99,9 @@ if get_option('introspection')
       'fwupd-release.c',
       'fwupd-release.h',
       'fwupd-release-private.h',
+      'fwupd-plugin.c',
+      'fwupd-plugin.h',
+      'fwupd-plugin-private.h',
       'fwupd-remote.c',
       'fwupd-remote.h',
       'fwupd-remote-private.h',
diff --git a/libfwupdplugin/fu-plugin.c b/libfwupdplugin/fu-plugin.c
index f7df74d68e..19c58ab514 100644
--- a/libfwupdplugin/fu-plugin.c
+++ b/libfwupdplugin/fu-plugin.c
@@ -37,11 +37,9 @@ static void fu_plugin_finalize			 (GObject *object);
 typedef struct {
 	GModule			*module;
 	GUsbContext		*usb_ctx;
-	gboolean		 enabled;
 	guint			 order;
 	guint			 priority;
 	GPtrArray		*rules[FU_PLUGIN_RULE_LAST];
-	gchar			*name;
 	gchar			*build_hash;
 	FuHwids			*hwids;
 	FuQuirks		*quirks;
@@ -71,7 +69,7 @@ enum {
 
 static guint signals[SIGNAL_LAST] = { 0 };
 
-G_DEFINE_TYPE_WITH_PRIVATE (FuPlugin, fu_plugin, G_TYPE_OBJECT)
+G_DEFINE_TYPE_WITH_PRIVATE (FuPlugin, fu_plugin, FWUPD_TYPE_PLUGIN)
 #define GET_PRIVATE(o) (fu_plugin_get_instance_private (o))
 
 typedef const gchar	*(*FuPluginGetNameFunc)		(void);
@@ -138,9 +136,8 @@ fu_plugin_is_open (FuPlugin *self)
 const gchar *
 fu_plugin_get_name (FuPlugin *self)
 {
-	FuPluginPrivate *priv = GET_PRIVATE (self);
 	g_return_val_if_fail (FU_IS_PLUGIN (self), NULL);
-	return priv->name;
+	return fwupd_plugin_get_name (FWUPD_PLUGIN (self));
 }
 
 /**
@@ -155,11 +152,8 @@ fu_plugin_get_name (FuPlugin *self)
 void
 fu_plugin_set_name (FuPlugin *self, const gchar *name)
 {
-	FuPluginPrivate *priv = GET_PRIVATE (self);
 	g_return_if_fail (FU_IS_PLUGIN (self));
-	g_return_if_fail (name != NULL);
-	g_free (priv->name);
-	priv->name = g_strdup (name);
+	fwupd_plugin_set_name (FWUPD_PLUGIN (self), name);
 }
 
 /**
@@ -364,9 +358,8 @@ fu_plugin_set_usb_context (FuPlugin *self, GUsbContext *usb_ctx)
 gboolean
 fu_plugin_get_enabled (FuPlugin *self)
 {
-	FuPluginPrivate *priv = GET_PRIVATE (self);
 	g_return_val_if_fail (FU_IS_PLUGIN (self), FALSE);
-	return priv->enabled;
+	return !fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED);
 }
 
 /**
@@ -381,9 +374,13 @@ fu_plugin_get_enabled (FuPlugin *self)
 void
 fu_plugin_set_enabled (FuPlugin *self, gboolean enabled)
 {
-	FuPluginPrivate *priv = GET_PRIVATE (self);
 	g_return_if_fail (FU_IS_PLUGIN (self));
-	priv->enabled = enabled;
+	if (enabled) {
+		fwupd_plugin_remove_flag (FWUPD_PLUGIN (self),
+					  FWUPD_PLUGIN_FLAG_DISABLED);
+	} else {
+		fu_plugin_add_flag (self, FWUPD_PLUGIN_FLAG_DISABLED);
+	}
 }
 
 /**
@@ -438,8 +435,10 @@ fu_plugin_open (FuPlugin *self, const gchar *filename, GError **error)
 	}
 
 	/* set automatically */
-	if (priv->name == NULL)
-		priv->name = fu_plugin_guess_name_from_fn (filename);
+	if (fu_plugin_get_name (self) == NULL) {
+		g_autofree gchar *str = fu_plugin_guess_name_from_fn (filename);
+		fu_plugin_set_name (self, str);
+	}
 
 	/* optional */
 	g_module_symbol (priv->module, "fu_plugin_init", (gpointer *) &func);
@@ -451,6 +450,27 @@ fu_plugin_open (FuPlugin *self, const gchar *filename, GError **error)
 	return TRUE;
 }
 
+/* order of usefullness to the user */
+static const gchar *
+fu_plugin_build_device_update_error (FuPlugin *self)
+{
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_NO_HARDWARE))
+		return "Not updatable as required hardware was not found";
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_LEGACY_BIOS))
+		return "Not updatable in legacy BIOS mode";
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED))
+		return "Not updatable as UEFI capsule updates not enabled";
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED))
+		return "Not updatable as requires unlock";
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED))
+		return "Not updatable as efivarfs was not found";
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND))
+		return "Not updatable as UEFI ESP partition not detected";
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
+		return "Not updatable as plugin was disabled";
+	return NULL;
+}
+
 /**
  * fu_plugin_device_add:
  * @self: A #FuPlugin
@@ -481,6 +501,21 @@ fu_plugin_device_add (FuPlugin *self, FuDevice *device)
 		return;
 	}
 
+	/* proxy to device where required */
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE)) {
+		g_debug ("plugin %s has _CLEAR_UPDATABLE, so removing from %s",
+			 fu_plugin_get_name (self),
+			 fu_device_get_id (device));
+		fu_device_remove_flag (device, FWUPD_DEVICE_FLAG_UPDATABLE);
+	}
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_USER_WARNING) &&
+	    fu_device_get_update_error (device) == NULL) {
+		const gchar *tmp = fu_plugin_build_device_update_error (self);
+		g_debug ("setting %s update error to '%s' from %s",
+			 fu_device_get_id (device), tmp, fu_plugin_get_name (self));
+		fu_device_set_update_error (device, tmp);
+	}
+
 	g_debug ("emit added from %s: %s",
 		 fu_plugin_get_name (self),
 		 fu_device_get_id (device));
@@ -1139,7 +1174,7 @@ fu_plugin_runner_startup (FuPlugin *self, GError **error)
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1150,11 +1185,11 @@ fu_plugin_runner_startup (FuPlugin *self, GError **error)
 	g_module_symbol (priv->module, "fu_plugin_startup", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("startup(%s)", priv->name);
+	g_debug ("startup(%s)", fu_plugin_get_name (self));
 	if (!func (self, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in startup(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1162,7 +1197,7 @@ fu_plugin_runner_startup (FuPlugin *self, GError **error)
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to startup using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1179,7 +1214,7 @@ fu_plugin_runner_device_generic (FuPlugin *self, FuDevice *device,
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1191,16 +1226,16 @@ fu_plugin_runner_device_generic (FuPlugin *self, FuDevice *device,
 	if (func == NULL) {
 		if (device_func != NULL) {
 			g_debug ("running superclassed %s(%s)",
-				 symbol_name + 10, priv->name);
+				 symbol_name + 10, fu_plugin_get_name (self));
 			return device_func (self, device, error);
 		}
 		return TRUE;
 	}
-	g_debug ("%s(%s)", symbol_name + 10, priv->name);
+	g_debug ("%s(%s)", symbol_name + 10, fu_plugin_get_name (self));
 	if (!func (self, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in %s(%s)",
-				    priv->name, symbol_name + 10);
+				    fu_plugin_get_name (self), symbol_name + 10);
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1208,7 +1243,7 @@ fu_plugin_runner_device_generic (FuPlugin *self, FuDevice *device,
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to %s using %s: ",
-					    symbol_name + 10, priv->name);
+					    symbol_name + 10, fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1224,7 +1259,7 @@ fu_plugin_runner_flagged_device_generic (FuPlugin *self, FwupdInstallFlags flags
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1235,11 +1270,11 @@ fu_plugin_runner_flagged_device_generic (FuPlugin *self, FwupdInstallFlags flags
 	g_module_symbol (priv->module, symbol_name, (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("%s(%s)", symbol_name + 10, priv->name);
+	g_debug ("%s(%s)", symbol_name + 10, fu_plugin_get_name (self));
 	if (!func (self, flags, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in %s(%s)",
-				    priv->name, symbol_name + 10);
+				    fu_plugin_get_name (self), symbol_name + 10);
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1247,7 +1282,7 @@ fu_plugin_runner_flagged_device_generic (FuPlugin *self, FwupdInstallFlags flags
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to %s using %s: ",
-					    symbol_name + 10, priv->name);
+					    symbol_name + 10, fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1263,7 +1298,7 @@ fu_plugin_runner_device_array_generic (FuPlugin *self, GPtrArray *devices,
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1274,11 +1309,11 @@ fu_plugin_runner_device_array_generic (FuPlugin *self, GPtrArray *devices,
 	g_module_symbol (priv->module, symbol_name, (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("%s(%s)", symbol_name + 10, priv->name);
+	g_debug ("%s(%s)", symbol_name + 10, fu_plugin_get_name (self));
 	if (!func (self, devices, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in for %s(%s)",
-				    priv->name, symbol_name + 10);
+				    fu_plugin_get_name (self), symbol_name + 10);
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1286,7 +1321,7 @@ fu_plugin_runner_device_array_generic (FuPlugin *self, GPtrArray *devices,
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to %s using %s: ",
-					    symbol_name + 10, priv->name);
+					    symbol_name + 10, fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1311,7 +1346,7 @@ fu_plugin_runner_coldplug (FuPlugin *self, GError **error)
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1322,18 +1357,18 @@ fu_plugin_runner_coldplug (FuPlugin *self, GError **error)
 	g_module_symbol (priv->module, "fu_plugin_coldplug", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("coldplug(%s)", priv->name);
+	g_debug ("coldplug(%s)", fu_plugin_get_name (self));
 	if (!func (self, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in coldplug(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
 					     "unspecified error");
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
-					    "failed to coldplug using %s: ", priv->name);
+					    "failed to coldplug using %s: ", fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1358,7 +1393,7 @@ fu_plugin_runner_recoldplug (FuPlugin *self, GError **error)
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1369,11 +1404,11 @@ fu_plugin_runner_recoldplug (FuPlugin *self, GError **error)
 	g_module_symbol (priv->module, "fu_plugin_recoldplug", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("recoldplug(%s)", priv->name);
+	g_debug ("recoldplug(%s)", fu_plugin_get_name (self));
 	if (!func (self, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in recoldplug(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1381,7 +1416,7 @@ fu_plugin_runner_recoldplug (FuPlugin *self, GError **error)
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to recoldplug using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1406,7 +1441,7 @@ fu_plugin_runner_coldplug_prepare (FuPlugin *self, GError **error)
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1417,11 +1452,11 @@ fu_plugin_runner_coldplug_prepare (FuPlugin *self, GError **error)
 	g_module_symbol (priv->module, "fu_plugin_coldplug_prepare", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("coldplug_prepare(%s)", priv->name);
+	g_debug ("coldplug_prepare(%s)", fu_plugin_get_name (self));
 	if (!func (self, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in coldplug_prepare(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1429,7 +1464,7 @@ fu_plugin_runner_coldplug_prepare (FuPlugin *self, GError **error)
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to coldplug_prepare using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1454,7 +1489,7 @@ fu_plugin_runner_coldplug_cleanup (FuPlugin *self, GError **error)
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1465,11 +1500,11 @@ fu_plugin_runner_coldplug_cleanup (FuPlugin *self, GError **error)
 	g_module_symbol (priv->module, "fu_plugin_coldplug_cleanup", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("coldplug_cleanup(%s)", priv->name);
+	g_debug ("coldplug_cleanup(%s)", fu_plugin_get_name (self));
 	if (!func (self, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in coldplug_cleanup(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1477,7 +1512,7 @@ fu_plugin_runner_coldplug_cleanup (FuPlugin *self, GError **error)
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to coldplug_cleanup using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1619,11 +1654,10 @@ fu_plugin_runner_update_detach (FuPlugin *self, FuDevice *device, GError **error
 gboolean
 fu_plugin_runner_update_reload (FuPlugin *self, FuDevice *device, GError **error)
 {
-	FuPluginPrivate *priv = GET_PRIVATE (self);
 	g_autoptr(FuDeviceLocker) locker = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1657,7 +1691,7 @@ fu_plugin_runner_add_security_attrs (FuPlugin *self, FuSecurityAttrs *attrs)
 	g_module_symbol (priv->module, symbol_name, (gpointer *) &func);
 	if (func == NULL)
 		return;
-	g_debug ("%s(%s)", symbol_name + 10, priv->name);
+	g_debug ("%s(%s)", symbol_name + 10, fu_plugin_get_name (self));
 	func (self, attrs);
 }
 
@@ -1839,7 +1873,7 @@ fu_plugin_runner_usb_device_added (FuPlugin *self, FuUsbDevice *device, GError *
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1856,11 +1890,11 @@ fu_plugin_runner_usb_device_added (FuPlugin *self, FuUsbDevice *device, GError *
 		}
 		return TRUE;
 	}
-	g_debug ("usb_device_added(%s)", priv->name);
+	g_debug ("usb_device_added(%s)", fu_plugin_get_name (self));
 	if (!func (self, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in usb_device_added(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1868,7 +1902,7 @@ fu_plugin_runner_usb_device_added (FuPlugin *self, FuUsbDevice *device, GError *
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to add device using on %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1894,7 +1928,7 @@ fu_plugin_runner_udev_device_added (FuPlugin *self, FuUdevDevice *device, GError
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1911,11 +1945,11 @@ fu_plugin_runner_udev_device_added (FuPlugin *self, FuUdevDevice *device, GError
 		}
 		return TRUE;
 	}
-	g_debug ("udev_device_added(%s)", priv->name);
+	g_debug ("udev_device_added(%s)", fu_plugin_get_name (self));
 	if (!func (self, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in udev_device_added(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1923,7 +1957,7 @@ fu_plugin_runner_udev_device_added (FuPlugin *self, FuUdevDevice *device, GError
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to add device using on %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1949,7 +1983,7 @@ fu_plugin_runner_udev_device_changed (FuPlugin *self, FuUdevDevice *device, GErr
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -1960,11 +1994,11 @@ fu_plugin_runner_udev_device_changed (FuPlugin *self, FuUdevDevice *device, GErr
 	g_module_symbol (priv->module, "fu_plugin_udev_device_changed", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("udev_device_changed(%s)", priv->name);
+	g_debug ("udev_device_changed(%s)", fu_plugin_get_name (self));
 	if (!func (self, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in udev_device_changed(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -1972,7 +2006,7 @@ fu_plugin_runner_udev_device_changed (FuPlugin *self, FuUdevDevice *device, GErr
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to change device on %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -1994,7 +2028,7 @@ fu_plugin_runner_device_added (FuPlugin *self, FuDevice *device)
 	FuPluginDeviceRegisterFunc func = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return;
 	if (priv->module == NULL)
 		return;
@@ -2003,7 +2037,7 @@ fu_plugin_runner_device_added (FuPlugin *self, FuDevice *device)
 	g_module_symbol (priv->module, "fu_plugin_device_added", (gpointer *) &func);
 	if (func == NULL)
 		return;
-	g_debug ("fu_plugin_device_added(%s)", priv->name);
+	g_debug ("fu_plugin_device_added(%s)", fu_plugin_get_name (self));
 	func (self, device);
 }
 
@@ -2044,7 +2078,7 @@ fu_plugin_runner_device_register (FuPlugin *self, FuDevice *device)
 	FuPluginDeviceRegisterFunc func = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return;
 	if (priv->module == NULL)
 		return;
@@ -2056,7 +2090,7 @@ fu_plugin_runner_device_register (FuPlugin *self, FuDevice *device)
 	/* optional */
 	g_module_symbol (priv->module, "fu_plugin_device_registered", (gpointer *) &func);
 	if (func != NULL) {
-		g_debug ("fu_plugin_device_registered(%s)", priv->name);
+		g_debug ("fu_plugin_device_registered(%s)", fu_plugin_get_name (self));
 		func (self, device);
 	}
 }
@@ -2080,7 +2114,7 @@ fu_plugin_runner_device_created (FuPlugin *self, FuDevice *device, GError **erro
 	FuPluginDeviceFunc func = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 	if (priv->module == NULL)
 		return TRUE;
@@ -2089,7 +2123,7 @@ fu_plugin_runner_device_created (FuPlugin *self, FuDevice *device, GError **erro
 	g_module_symbol (priv->module, "fu_plugin_device_created", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("fu_plugin_device_created(%s)", priv->name);
+	g_debug ("fu_plugin_device_created(%s)", fu_plugin_get_name (self));
 	return func (self, device, error);
 }
 
@@ -2118,7 +2152,7 @@ fu_plugin_runner_verify (FuPlugin *self,
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -2143,12 +2177,12 @@ fu_plugin_runner_verify (FuPlugin *self,
 		return FALSE;
 
 	/* run vfunc */
-	g_debug ("verify(%s)", priv->name);
+	g_debug ("verify(%s)", fu_plugin_get_name (self));
 	if (!func (self, device, flags, &error_local)) {
 		g_autoptr(GError) error_attach = NULL;
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in verify(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -2156,7 +2190,7 @@ fu_plugin_runner_verify (FuPlugin *self,
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to verify using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		/* make the device "work" again, but don't prefix the error */
 		if (!fu_plugin_runner_device_generic (self, device,
 						      "fu_plugin_update_attach",
@@ -2288,7 +2322,7 @@ fu_plugin_runner_update (FuPlugin *self,
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled) {
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED)) {
 		g_debug ("plugin not enabled, skipping");
 		return TRUE;
 	}
@@ -2302,7 +2336,7 @@ fu_plugin_runner_update (FuPlugin *self,
 	/* optional */
 	g_module_symbol (priv->module, "fu_plugin_update", (gpointer *) &update_func);
 	if (update_func == NULL) {
-		g_debug ("superclassed write_firmware(%s)", priv->name);
+		g_debug ("superclassed write_firmware(%s)", fu_plugin_get_name (self));
 		return fu_plugin_device_write_firmware (self, device, blob_fw, flags, error);
 	}
 
@@ -2310,7 +2344,7 @@ fu_plugin_runner_update (FuPlugin *self,
 	if (!update_func (self, device, blob_fw, flags, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in update(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -2353,7 +2387,7 @@ fu_plugin_runner_clear_results (FuPlugin *self, FuDevice *device, GError **error
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -2364,11 +2398,11 @@ fu_plugin_runner_clear_results (FuPlugin *self, FuDevice *device, GError **error
 	g_module_symbol (priv->module, "fu_plugin_clear_results", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("clear_result(%s)", priv->name);
+	g_debug ("clear_result(%s)", fu_plugin_get_name (self));
 	if (!func (self, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in clear_result(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -2376,7 +2410,7 @@ fu_plugin_runner_clear_results (FuPlugin *self, FuDevice *device, GError **error
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to clear_result using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -2402,7 +2436,7 @@ fu_plugin_runner_get_results (FuPlugin *self, FuDevice *device, GError **error)
 	g_autoptr(GError) error_local = NULL;
 
 	/* not enabled */
-	if (!priv->enabled)
+	if (fu_plugin_has_flag (self, FWUPD_PLUGIN_FLAG_DISABLED))
 		return TRUE;
 
 	/* no object loaded */
@@ -2413,11 +2447,11 @@ fu_plugin_runner_get_results (FuPlugin *self, FuDevice *device, GError **error)
 	g_module_symbol (priv->module, "fu_plugin_get_results", (gpointer *) &func);
 	if (func == NULL)
 		return TRUE;
-	g_debug ("get_results(%s)", priv->name);
+	g_debug ("get_results(%s)", fu_plugin_get_name (self));
 	if (!func (self, device, &error_local)) {
 		if (error_local == NULL) {
 			g_critical ("unset plugin error in get_results(%s)",
-				    priv->name);
+				    fu_plugin_get_name (self));
 			g_set_error_literal (&error_local,
 					     FWUPD_ERROR,
 					     FWUPD_ERROR_INTERNAL,
@@ -2425,7 +2459,7 @@ fu_plugin_runner_get_results (FuPlugin *self, FuDevice *device, GError **error)
 		}
 		g_propagate_prefixed_error (error, g_steal_pointer (&error_local),
 					    "failed to get_results using %s: ",
-					    priv->name);
+					    fu_plugin_get_name (self));
 		return FALSE;
 	}
 	return TRUE;
@@ -2678,9 +2712,7 @@ fu_plugin_get_config_value_boolean (FuPlugin *self, const gchar *key)
 gint
 fu_plugin_name_compare (FuPlugin *plugin1, FuPlugin *plugin2)
 {
-	FuPluginPrivate *priv1 = fu_plugin_get_instance_private (plugin1);
-	FuPluginPrivate *priv2 = fu_plugin_get_instance_private (plugin2);
-	return g_strcmp0 (priv1->name, priv2->name);
+	return g_strcmp0 (fu_plugin_get_name (plugin1), fu_plugin_get_name (plugin2));
 }
 
 /**
@@ -2771,7 +2803,6 @@ static void
 fu_plugin_init (FuPlugin *self)
 {
 	FuPluginPrivate *priv = GET_PRIVATE (self);
-	priv->enabled = TRUE;
 	g_rw_lock_init (&priv->devices_mutex);
 }
 
@@ -2788,7 +2819,7 @@ fu_plugin_finalize (GObject *object)
 	if (priv->module != NULL) {
 		g_module_symbol (priv->module, "fu_plugin_destroy", (gpointer *) &func);
 		if (func != NULL) {
-			g_debug ("destroy(%s)", priv->name);
+			g_debug ("destroy(%s)", fu_plugin_get_name (self));
 			func (self);
 		}
 	}
@@ -2816,7 +2847,6 @@ fu_plugin_finalize (GObject *object)
 	if (priv->devices != NULL)
 		g_hash_table_unref (priv->devices);
 	g_free (priv->build_hash);
-	g_free (priv->name);
 	g_free (priv->data);
 	/* Must happen as the last step to avoid prematurely
 	 * freeing memory held by the plugin */
diff --git a/libfwupdplugin/fu-plugin.h b/libfwupdplugin/fu-plugin.h
index 671d5a12d2..0b232eb8d4 100644
--- a/libfwupdplugin/fu-plugin.h
+++ b/libfwupdplugin/fu-plugin.h
@@ -22,13 +22,18 @@
 #include "fu-udev-device.h"
 #endif
 #include "fwupd-common.h"
+#include "fwupd-plugin.h"
 
 #define FU_TYPE_PLUGIN (fu_plugin_get_type ())
-G_DECLARE_DERIVABLE_TYPE (FuPlugin, fu_plugin, FU, PLUGIN, GObject)
+G_DECLARE_DERIVABLE_TYPE (FuPlugin, fu_plugin, FU, PLUGIN, FwupdPlugin)
+
+#define fu_plugin_get_flags(p)			fwupd_plugin_get_flags(FWUPD_PLUGIN(p))
+#define fu_plugin_has_flag(p,f)			fwupd_plugin_has_flag(FWUPD_PLUGIN(p),f)
+#define fu_plugin_add_flag(p,f)			fwupd_plugin_add_flag(FWUPD_PLUGIN(p),f)
 
 struct _FuPluginClass
 {
-	GObjectClass	 parent_class;
+	FwupdPluginClass parent_class;
 	/* signals */
 	void		 (* device_added)		(FuPlugin	*self,
 							 FuDevice	*device);
@@ -96,9 +101,11 @@ const gchar	*fu_plugin_get_name			(FuPlugin	*self);
 FuPluginData	*fu_plugin_get_data			(FuPlugin	*self);
 FuPluginData	*fu_plugin_alloc_data			(FuPlugin	*self,
 							 gsize		 data_sz);
-gboolean	 fu_plugin_get_enabled			(FuPlugin	*self);
+gboolean	 fu_plugin_get_enabled			(FuPlugin	*self)
+G_DEPRECATED_FOR(fu_plugin_has_flag);
 void		 fu_plugin_set_enabled			(FuPlugin	*self,
-							 gboolean	 enabled);
+							 gboolean	 enabled)
+G_DEPRECATED_FOR(fu_plugin_add_flag);
 void		 fu_plugin_set_build_hash		(FuPlugin	*self,
 							 const gchar	*build_hash);
 GUsbContext	*fu_plugin_get_usb_context		(FuPlugin	*self);
diff --git a/plugins/bios/fu-plugin-bios.c b/plugins/bios/fu-plugin-bios.c
index b229bd6274..ef8bbddb11 100644
--- a/plugins/bios/fu-plugin-bios.c
+++ b/plugins/bios/fu-plugin-bios.c
@@ -16,7 +16,6 @@ fu_plugin_init (FuPlugin *plugin)
 	fu_plugin_set_build_hash (plugin, FU_BUILD_HASH);
 }
 
-
 gboolean
 fu_plugin_startup (FuPlugin *plugin, GError **error)
 {
@@ -34,41 +33,6 @@ fu_plugin_startup (FuPlugin *plugin, GError **error)
 	return TRUE;
 }
 
-
-static gboolean
-fu_plugin_bios_create_dummy (FuPlugin *plugin, const gchar *reason, GError **error)
-{
-	const gchar *key;
-	g_autoptr(FuDevice) dev = fu_device_new ();
-
-	fu_device_set_version_format (dev, FWUPD_VERSION_FORMAT_PLAIN);
-	key = fu_plugin_get_dmi_value (plugin, FU_HWIDS_KEY_MANUFACTURER);
-	if (key != NULL)
-		fu_device_set_vendor (dev, key);
-	key = fu_plugin_get_dmi_value (plugin, FU_HWIDS_KEY_BIOS_VENDOR);
-	if (key != NULL) {
-		g_autofree gchar *vendor_id = g_strdup_printf ("DMI:%s", key);
-		fu_device_set_vendor_id (FU_DEVICE (dev), vendor_id);
-	}
-	key = "System Firmware";
-	fu_device_set_name (dev, key);
-	key = fu_plugin_get_dmi_value (plugin, FU_HWIDS_KEY_BIOS_VERSION);
-	if (key != NULL)
-		fu_device_set_version (dev, key);
-	fu_device_set_update_error (dev, reason);
-
-	fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_INTERNAL);
-
-	fu_device_add_icon (dev, "computer");
-	fu_device_set_id (dev, "BIOS-dummy");
-	fu_device_add_instance_id (dev, "main-system-firmware");
-	if (!fu_device_setup (dev, error))
-		return FALSE;
-	fu_plugin_device_add (plugin, dev);
-
-	return TRUE;
-}
-
 gboolean
 fu_plugin_coldplug (FuPlugin *plugin, GError **error)
 {
@@ -79,9 +43,9 @@ fu_plugin_coldplug (FuPlugin *plugin, GError **error)
 #if defined(__x86_64__) || defined(__i386__)
 	g_autoptr(GError) error_local = NULL;
 	if (!fu_efivar_supported (&error_local)) {
-		const gchar *reason = "Firmware can not be updated in legacy BIOS mode, switch to UEFI mode";
-		g_warning ("%s", error_local->message);
-		return fu_plugin_bios_create_dummy (plugin, reason, error);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_LEGACY_BIOS);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING);
+		return TRUE;
 	}
 #endif
 
@@ -89,12 +53,12 @@ fu_plugin_coldplug (FuPlugin *plugin, GError **error)
 	sysfsfwdir = fu_common_get_path (FU_PATH_KIND_SYSFSDIR_FW);
 	esrt_path = g_build_filename (sysfsfwdir, "efi", "esrt", NULL);
 	if (!g_file_test (esrt_path, G_FILE_TEST_IS_DIR)) {
-		const gchar *reason = "UEFI Capsule updates not available or enabled";
-		return fu_plugin_bios_create_dummy (plugin, reason, error);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING);
+		return TRUE;
 	}
 
 	/* we appear to have UEFI capsule updates */
-	fu_plugin_set_enabled (plugin, FALSE);
-
+	fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED);
 	return TRUE;
 }
diff --git a/plugins/dell/fu-plugin-dell.c b/plugins/dell/fu-plugin-dell.c
index 90ba57c575..3b500da243 100644
--- a/plugins/dell/fu-plugin-dell.c
+++ b/plugins/dell/fu-plugin-dell.c
@@ -286,9 +286,6 @@ fu_plugin_dock_node (FuPlugin *plugin, const gchar *platform,
 		if (fu_plugin_dell_capsule_supported (plugin)) {
 			fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_UPDATABLE);
 			fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_NEEDS_REBOOT);
-		} else {
-			fu_device_set_update_error (dev,
-						    "UEFI capsule updates turned off in BIOS setup");
 		}
 	}
 
@@ -734,9 +731,6 @@ fu_plugin_dell_detect_tpm (FuPlugin *plugin, GError **error)
 		if (fu_plugin_dell_capsule_supported (plugin)) {
 			fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_UPDATABLE);
 			fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_NEEDS_REBOOT);
-		} else {
-			fu_device_set_update_error (dev,
-						    "UEFI capsule updates turned off in BIOS setup");
 		}
 		fu_device_set_flashes_left (dev, out->flashes_left);
 	} else {
@@ -892,10 +886,14 @@ fu_plugin_startup (FuPlugin *plugin, GError **error)
 	 */
 	sysfsfwdir = fu_common_get_path (FU_PATH_KIND_SYSFSDIR_FW);
 	esrtdir = g_build_filename (sysfsfwdir, "efi", "esrt", NULL);
-	if (g_file_test (esrtdir, G_FILE_TEST_EXISTS)) {
+	if (g_file_test (esrtdir, G_FILE_TEST_EXISTS))
 		data->capsule_supported = TRUE;
-	} else {
-		g_debug ("UEFI capsule firmware updating not supported");
+
+	/* capsules not supported */
+	if (!fu_plugin_dell_capsule_supported (plugin)) {
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED);
 	}
 
 	return TRUE;
diff --git a/plugins/tpm-eventlog/fu-plugin-tpm-eventlog.c b/plugins/tpm-eventlog/fu-plugin-tpm-eventlog.c
index aed42f21c8..c03713611a 100644
--- a/plugins/tpm-eventlog/fu-plugin-tpm-eventlog.c
+++ b/plugins/tpm-eventlog/fu-plugin-tpm-eventlog.c
@@ -147,7 +147,7 @@ fu_plugin_add_security_attrs (FuPlugin *plugin, FuSecurityAttrs *attrs)
 	fu_security_attrs_append (attrs, attr);
 
 	/* check reconstructed to PCR0 */
-	if (!fu_plugin_get_enabled (plugin) || !data->has_uefi_device) {
+	if (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED) || !data->has_uefi_device) {
 		fwupd_security_attr_set_result (attr, FWUPD_SECURITY_ATTR_RESULT_NOT_FOUND);
 		return;
 	}
diff --git a/plugins/uefi/fu-plugin-uefi.c b/plugins/uefi/fu-plugin-uefi.c
index 087932a2fc..0be6e16142 100644
--- a/plugins/uefi/fu-plugin-uefi.c
+++ b/plugins/uefi/fu-plugin-uefi.c
@@ -758,13 +758,21 @@ fu_plugin_coldplug (FuPlugin *plugin, GError **error)
 		return FALSE;
 
 	/* make sure that efivarfs is rw */
-	if (!fu_plugin_uefi_ensure_efivarfs_rw (&error_efivarfs))
+	if (!fu_plugin_uefi_ensure_efivarfs_rw (&error_efivarfs)) {
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE);
+		fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING);
 		g_warning ("%s", error_efivarfs->message);
+	}
 
 	if (data->esp == NULL) {
 		data->esp = fu_common_get_esp_default (&error_udisks2);
-		if (data->esp == NULL)
+		if (data->esp == NULL) {
+			fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND);
+			fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE);
+			fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING);
 			g_warning ("cannot find default ESP: %s", error_udisks2->message);
+		}
 	}
 
 	/* add each device */
@@ -781,14 +789,9 @@ fu_plugin_coldplug (FuPlugin *plugin, GError **error)
 			fu_uefi_device_set_esp (FU_UEFI_DEVICE (dev), data->esp);
 		if (!fu_plugin_uefi_coldplug_device (plugin, dev, error))
 			return FALSE;
-		if (error_efivarfs != NULL) {
-			fu_device_set_update_error (FU_DEVICE (dev), error_efivarfs->message);
-		} else if (error_udisks2 != NULL) {
-			fu_device_set_update_error (FU_DEVICE (dev), error_udisks2->message);
-		} else {
-			fu_device_add_flag (FU_DEVICE (dev), FWUPD_DEVICE_FLAG_UPDATABLE);
-			fu_device_add_flag (FU_DEVICE (dev), FWUPD_DEVICE_FLAG_USABLE_DURING_UPDATE);
-		}
+		fu_device_add_flag (FU_DEVICE (dev), FWUPD_DEVICE_FLAG_UPDATABLE);
+		fu_device_add_flag (FU_DEVICE (dev), FWUPD_DEVICE_FLAG_USABLE_DURING_UPDATE);
+
 		/* load all configuration variables */
 		fu_plugin_uefi_load_config (plugin, FU_DEVICE (dev));
 		fu_plugin_device_add (plugin, FU_DEVICE (dev));
diff --git a/src/fu-engine.c b/src/fu-engine.c
index 9188a95600..c7f6aa0123 100644
--- a/src/fu-engine.c
+++ b/src/fu-engine.c
@@ -4899,7 +4899,12 @@ fu_engine_plugins_setup (FuEngine *self)
 		g_autoptr(GError) error = NULL;
 		FuPlugin *plugin = g_ptr_array_index (plugins, i);
 		if (!fu_plugin_runner_startup (plugin, &error)) {
-			fu_plugin_set_enabled (plugin, FALSE);
+			fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED);
+			if (g_error_matches (error,
+					     FWUPD_ERROR,
+					     FWUPD_ERROR_NOT_SUPPORTED)) {
+				fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_NO_HARDWARE);
+			}
 			g_message ("disabling plugin because: %s", error->message);
 		}
 	}
@@ -4938,7 +4943,7 @@ fu_engine_plugins_coldplug (FuEngine *self, gboolean is_recoldplug)
 				g_message ("failed recoldplug: %s", error->message);
 		} else {
 			if (!fu_plugin_runner_coldplug (plugin, &error)) {
-				fu_plugin_set_enabled (plugin, FALSE);
+				fu_plugin_add_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED);
 				g_message ("disabling plugin because: %s",
 					   error->message);
 			}
@@ -4956,7 +4961,7 @@ fu_engine_plugins_coldplug (FuEngine *self, gboolean is_recoldplug)
 	/* print what we do have */
 	for (guint i = 0; i < plugins->len; i++) {
 		FuPlugin *plugin = g_ptr_array_index (plugins, i);
-		if (!fu_plugin_get_enabled (plugin))
+		if (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED))
 			continue;
 		g_string_append_printf (str, "%s, ", fu_plugin_get_name (plugin));
 	}
@@ -5843,8 +5848,7 @@ fu_engine_load_plugins (FuEngine *self, GError **error)
 	g_autofree gchar *plugin_path = NULL;
 	g_autofree gchar *suffix = g_strdup_printf (".%s", G_MODULE_SUFFIX);
 	g_autoptr(GPtrArray) plugins_disabled = g_ptr_array_new_with_free_func (g_free);
-	g_autoptr(GPtrArray) plugins_not_enabled = g_ptr_array_new_with_free_func (g_free);
-	g_autoptr(GPtrArray) plugins_self_disabled = g_ptr_array_new_with_free_func (g_free);
+	g_autoptr(GPtrArray) plugins_disabled_rt = g_ptr_array_new_with_free_func (g_free);
 
 	/* search */
 	plugin_path = fu_common_get_path (FU_PATH_KIND_PLUGINDIR_PKG);
@@ -5865,14 +5869,11 @@ fu_engine_load_plugins (FuEngine *self, GError **error)
 		name = fu_plugin_guess_name_from_fn (fn);
 		if (name == NULL)
 			continue;
-		if (fu_engine_is_plugin_name_disabled (self, name)) {
+		if (fu_engine_is_plugin_name_disabled (self, name) ||
+		    !fu_engine_is_plugin_name_enabled (self, name)) {
 			g_ptr_array_add (plugins_disabled, g_steal_pointer (&name));
 			continue;
 		}
-		if (!fu_engine_is_plugin_name_enabled (self, name)) {
-			g_ptr_array_add (plugins_not_enabled, g_steal_pointer (&name));
-			continue;
-		}
 
 		/* open module */
 		filename = g_build_filename (plugin_path, fn, NULL);
@@ -5897,9 +5898,9 @@ fu_engine_load_plugins (FuEngine *self, GError **error)
 			}
 		}
 
-		/* self disabled */
-		if (!fu_plugin_get_enabled (plugin)) {
-			g_ptr_array_add (plugins_self_disabled, g_steal_pointer (&name));
+		/* runtime disabled */
+		if (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED)) {
+			g_ptr_array_add (plugins_disabled_rt, g_steal_pointer (&name));
 			continue;
 		}
 
@@ -5940,17 +5941,11 @@ fu_engine_load_plugins (FuEngine *self, GError **error)
 		str = g_strjoinv (", ", (gchar **) plugins_disabled->pdata);
 		g_debug ("plugins disabled: %s", str);
 	}
-	if (plugins_not_enabled->len > 0) {
-		g_autofree gchar *str = NULL;
-		g_ptr_array_add (plugins_not_enabled, NULL);
-		str = g_strjoinv (", ", (gchar **) plugins_not_enabled->pdata);
-		g_debug ("plugins not-enabled: %s", str);
-	}
-	if (plugins_self_disabled->len > 0) {
+	if (plugins_disabled_rt->len > 0) {
 		g_autofree gchar *str = NULL;
-		g_ptr_array_add (plugins_self_disabled, NULL);
-		str = g_strjoinv (", ", (gchar **) plugins_self_disabled->pdata);
-		g_debug ("plugins self-disabled: %s", str);
+		g_ptr_array_add (plugins_disabled_rt, NULL);
+		str = g_strjoinv (", ", (gchar **) plugins_disabled_rt->pdata);
+		g_debug ("plugins runtime-disabled: %s", str);
 	}
 
 	/* depsolve into the correct order */
diff --git a/src/fu-main.c b/src/fu-main.c
index de6c3d237a..0af2288c50 100644
--- a/src/fu-main.c
+++ b/src/fu-main.c
@@ -20,6 +20,7 @@
 #include <jcat.h>
 
 #include "fwupd-device-private.h"
+#include "fwupd-plugin-private.h"
 #include "fwupd-security-attr-private.h"
 #include "fwupd-release-private.h"
 #include "fwupd-remote-private.h"
@@ -269,6 +270,22 @@ fu_main_device_array_to_variant (FuMainPrivate *priv, FuEngineRequest *request,
 	return g_variant_new ("(aa{sv})", &builder);
 }
 
+static GVariant *
+fu_main_plugin_array_to_variant (GPtrArray *plugins)
+{
+	GVariantBuilder builder;
+
+	g_return_val_if_fail (plugins->len > 0, NULL);
+	g_variant_builder_init (&builder, G_VARIANT_TYPE_ARRAY);
+
+	for (guint i = 0; i < plugins->len; i++) {
+		FuDevice *plugin = g_ptr_array_index (plugins, i);
+		GVariant *tmp = fwupd_plugin_to_variant (FWUPD_PLUGIN (plugin));
+		g_variant_builder_add_value (&builder, tmp);
+	}
+	return g_variant_new ("(aa{sv})", &builder);
+}
+
 static GVariant *
 fu_main_release_array_to_variant (GPtrArray *results)
 {
@@ -882,6 +899,12 @@ fu_main_daemon_method_call (GDBusConnection *connection, const gchar *sender,
 		g_dbus_method_invocation_return_value (invocation, val);
 		return;
 	}
+	if (g_strcmp0 (method_name, "GetPlugins") == 0) {
+		g_debug ("Called %s()", method_name);
+		val = fu_main_plugin_array_to_variant (fu_engine_get_plugins (priv->engine));
+		g_dbus_method_invocation_return_value (invocation, val);
+		return;
+	}
 	if (g_strcmp0 (method_name, "GetReleases") == 0) {
 		const gchar *device_id;
 		g_autoptr(GPtrArray) releases = NULL;
diff --git a/src/fu-plugin-list.c b/src/fu-plugin-list.c
index 5283a5278a..777bbe0c40 100644
--- a/src/fu-plugin-list.c
+++ b/src/fu-plugin-list.c
@@ -157,7 +157,7 @@ fu_plugin_list_depsolve (FuPluginList *self, GError **error)
 						 fu_plugin_get_name (plugin));
 					continue;
 				}
-				if (!fu_plugin_get_enabled (dep))
+				if (fu_plugin_has_flag (dep, FWUPD_PLUGIN_FLAG_DISABLED))
 					continue;
 				if (fu_plugin_get_order (plugin) <= fu_plugin_get_order (dep)) {
 					g_debug ("%s [%u] to be ordered after %s [%u] "
@@ -187,7 +187,7 @@ fu_plugin_list_depsolve (FuPluginList *self, GError **error)
 						 fu_plugin_get_name (plugin));
 					continue;
 				}
-				if (!fu_plugin_get_enabled (dep))
+				if (fu_plugin_has_flag (dep, FWUPD_PLUGIN_FLAG_DISABLED))
 					continue;
 				if (fu_plugin_get_order (plugin) >= fu_plugin_get_order (dep)) {
 					g_debug ("%s [%u] to be ordered before %s [%u] "
@@ -219,7 +219,7 @@ fu_plugin_list_depsolve (FuPluginList *self, GError **error)
 						 fu_plugin_get_name (plugin));
 					continue;
 				}
-				if (!fu_plugin_get_enabled (dep))
+				if (fu_plugin_has_flag (dep, FWUPD_PLUGIN_FLAG_DISABLED))
 					continue;
 				if (fu_plugin_get_priority (plugin) <= fu_plugin_get_priority (dep)) {
 					g_debug ("%s [%u] better than %s [%u] "
@@ -248,7 +248,7 @@ fu_plugin_list_depsolve (FuPluginList *self, GError **error)
 	/* check for conflicts */
 	for (guint i = 0; i < self->plugins->len; i++) {
 		FuPlugin *plugin = g_ptr_array_index (self->plugins, i);
-		if (!fu_plugin_get_enabled (plugin))
+		if (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED))
 			continue;
 		deps = fu_plugin_get_rules (plugin, FU_PLUGIN_RULE_CONFLICTS);
 		if (deps == NULL)
@@ -258,12 +258,12 @@ fu_plugin_list_depsolve (FuPluginList *self, GError **error)
 			dep = fu_plugin_list_find_by_name (self, plugin_name, NULL);
 			if (dep == NULL)
 				continue;
-			if (!fu_plugin_get_enabled (dep))
+			if (fu_plugin_has_flag (dep, FWUPD_PLUGIN_FLAG_DISABLED))
 				continue;
 			g_debug ("disabling %s as conflicts with %s",
 				 fu_plugin_get_name (dep),
 				 fu_plugin_get_name (plugin));
-			fu_plugin_set_enabled (dep, FALSE);
+			fu_plugin_add_flag (dep, FWUPD_PLUGIN_FLAG_DISABLED);
 		}
 	}
 
diff --git a/src/fu-self-test.c b/src/fu-self-test.c
index 903edba41f..0caaf197df 100644
--- a/src/fu-self-test.c
+++ b/src/fu-self-test.c
@@ -2395,7 +2395,7 @@ fu_plugin_list_depsolve_func (gconstpointer user_data)
 	plugin = g_ptr_array_index (plugins, 0);
 	g_assert_cmpstr (fu_plugin_get_name (plugin), ==, "plugin2");
 	g_assert_cmpint (fu_plugin_get_order (plugin), ==, 0);
-	g_assert (fu_plugin_get_enabled (plugin));
+	g_assert_false (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED));
 
 	/* add another rule, then re-depsolve */
 	fu_plugin_add_rule (plugin1, FU_PLUGIN_RULE_CONFLICTS, "plugin2");
@@ -2405,11 +2405,11 @@ fu_plugin_list_depsolve_func (gconstpointer user_data)
 	plugin = fu_plugin_list_find_by_name (plugin_list, "plugin1", &error);
 	g_assert_no_error (error);
 	g_assert (plugin != NULL);
-	g_assert (fu_plugin_get_enabled (plugin));
+	g_assert_false (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED));
 	plugin = fu_plugin_list_find_by_name (plugin_list, "plugin2", &error);
 	g_assert_no_error (error);
 	g_assert (plugin != NULL);
-	g_assert (!fu_plugin_get_enabled (plugin));
+	g_assert_true (fu_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_DISABLED));
 }
 
 static void
diff --git a/src/fu-tool.c b/src/fu-tool.c
index 8bde01271c..b6a534bcd7 100644
--- a/src/fu-tool.c
+++ b/src/fu-tool.c
@@ -120,6 +120,40 @@ fu_util_save_current_state (FuUtilPrivate *priv, GError **error)
 	return g_file_set_contents (filename, state, -1, error);
 }
 
+static void
+fu_util_show_plugin_warnings (FuUtilPrivate *priv)
+{
+	FwupdPluginFlags flags = FWUPD_PLUGIN_FLAG_NONE;
+	GPtrArray *plugins;
+
+	/* get a superset so we do not show the same message more than once */
+	plugins = fu_engine_get_plugins (priv->engine);
+	for (guint i = 0; i < plugins->len; i++) {
+		FwupdPlugin *plugin = g_ptr_array_index (plugins, i);
+		if (!fwupd_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING))
+			continue;
+		flags |= fwupd_plugin_get_flags (plugin);
+	}
+
+	/* never show these, they're way too generic */
+	flags &= ~FWUPD_PLUGIN_FLAG_DISABLED;
+	flags &= ~FWUPD_PLUGIN_FLAG_NO_HARDWARE;
+
+	/* print */
+	for (guint i = 0; i < 64; i++) {
+		const gchar *tmp;
+		g_autofree gchar *fmt = NULL;
+		if ((flags & ((guint64) 1 << i)) == 0)
+			continue;
+		tmp = fu_util_plugin_flag_to_string ((guint64) 1 << i);
+		if (tmp == NULL)
+			continue;
+		/* TRANSLATORS: this is a prefix on the console */
+		fmt = fu_util_term_format (_("WARNING:"), FU_UTIL_TERM_COLOR_RED);
+		g_printerr ("%s %s\n", fmt, tmp);
+	}
+}
+
 static gboolean
 fu_util_start_engine (FuUtilPrivate *priv, FuEngineLoadFlags flags, GError **error)
 {
@@ -132,9 +166,15 @@ fu_util_start_engine (FuUtilPrivate *priv, FuEngineLoadFlags flags, GError **err
 	if (!fu_engine_load (priv->engine, flags, error))
 		return FALSE;
 	if (fu_engine_get_tainted (priv->engine)) {
-		g_printerr ("WARNING: This tool has loaded 3rd party code and "
-			    "is no longer supported by the upstream developers!\n");
+		g_autofree gchar *fmt = NULL;
+
+		/* TRANSLATORS: this is a prefix on the console */
+		fmt = fu_util_term_format (_("WARNING:"), FU_UTIL_TERM_COLOR_RED);
+		g_printerr ("%s This tool has loaded 3rd party code and "
+			    "is no longer supported by the upstream developers!\n",
+			    fmt);
 	}
+	fu_util_show_plugin_warnings (priv);
 	return TRUE;
 }
 
@@ -269,10 +309,9 @@ static gboolean
 fu_util_get_plugins (FuUtilPrivate *priv, gchar **values, GError **error)
 {
 	GPtrArray *plugins;
-	guint cnt = 0;
 
 	/* load engine */
-	if (!fu_engine_load_plugins (priv->engine, error))
+	if (!fu_util_start_engine (priv, FU_ENGINE_LOAD_FLAG_NONE, error))
 		return FALSE;
 
 	/* print */
@@ -280,15 +319,12 @@ fu_util_get_plugins (FuUtilPrivate *priv, gchar **values, GError **error)
 	g_ptr_array_sort (plugins, (GCompareFunc) fu_util_plugin_name_sort_cb);
 	for (guint i = 0; i < plugins->len; i++) {
 		FuPlugin *plugin = g_ptr_array_index (plugins, i);
-		if (!fu_plugin_get_enabled (plugin))
-			continue;
-		g_print ("%s\n", fu_plugin_get_name (plugin));
-		cnt++;
+		g_autofree gchar *str = fu_util_plugin_to_string (FWUPD_PLUGIN (plugin), 0);
+		g_print ("%s\n", str);
 	}
-	if (cnt == 0) {
+	if (plugins->len == 0) {
 		/* TRANSLATORS: nothing found */
 		g_print ("%s\n", _("No plugins found"));
-		return TRUE;
 	}
 
 	return TRUE;
@@ -2761,10 +2797,13 @@ main (int argc, char *argv[])
 
 	/* allow disabling SSL strict mode for broken corporate proxies */
 	if (priv->disable_ssl_strict) {
+		g_autofree gchar *fmt = NULL;
+		/* TRANSLATORS: this is a prefix on the console */
+		fmt = fu_util_term_format (_("WARNING:"), FU_UTIL_TERM_COLOR_RED);
 		/* TRANSLATORS: try to help */
-		g_printerr ("%s\n", _("WARNING: Ignoring SSL strict checks, "
-				      "to do this automatically in the future "
-				      "export DISABLE_SSL_STRICT in your environment"));
+		g_printerr ("%s %s\n", fmt, _("Ignoring SSL strict checks, "
+					      "to do this automatically in the future "
+					      "export DISABLE_SSL_STRICT in your environment"));
 		g_setenv ("DISABLE_SSL_STRICT", "1", TRUE);
 	}
 
diff --git a/src/fu-util-common.c b/src/fu-util-common.c
index 3daf56e3ba..88fa803a50 100644
--- a/src/fu-util-common.c
+++ b/src/fu-util-common.c
@@ -12,6 +12,7 @@
 #include <glib/gi18n.h>
 #include <gusb.h>
 #include <xmlb.h>
+#include <fwupd.h>
 
 #include "fu-common.h"
 #include "fu-device-private.h"
@@ -35,6 +36,12 @@ fu_util_get_systemd_unit (void)
 	return SYSTEMD_FWUPD_UNIT;
 }
 
+gchar *
+fu_util_term_format (const gchar *text, FuUtilTermColor fg_color)
+{
+	return g_strdup_printf ("\033[%um\033[1m%s\033[0m", fg_color, text);
+}
+
 #ifdef HAVE_SYSTEMD
 static const gchar *
 fu_util_get_expected_command (const gchar *target)
@@ -1286,6 +1293,117 @@ fu_util_device_to_string (FwupdDevice *dev, guint idt)
 	return g_string_free (str, FALSE);
 }
 
+const gchar *
+fu_util_plugin_flag_to_string (FwupdPluginFlags plugin_flag)
+{
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_UNKNOWN)
+		return NULL;
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE)
+		return NULL;
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_USER_WARNING)
+		return NULL;
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_NONE) {
+		/* TRANSLATORS: Plugin is active and in use */
+		return _("Enabled");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_DISABLED) {
+		/* TRANSLATORS: Plugin is inactive and not used */
+		return _("Disabled");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_NO_HARDWARE) {
+		/* TRANSLATORS: not required for this system */
+		return _("Required hardware was not found");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_LEGACY_BIOS) {
+		/* TRANSLATORS: system is not booted in UEFI mode */
+		return _("Firmware can not be updated in legacy BIOS mode");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED) {
+		/* TRANSLATORS: capsule updates are an optional BIOS feature */
+		return _("UEFI capsule updates not available or enabled");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED) {
+		/* TRANSLATORS: user needs to run a command */
+		return _("Firmware updates disabled; run 'fwupdmgr unlock' to enable");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED) {
+		/* TRANSLATORS: the user is using Gentoo/Arch and has screwed something up */
+		return _("Required efivarfs filesystem was not found");
+	}
+	if (plugin_flag == FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND) {
+		/* TRANSLATORS: partition refers to something on disk, again, hey Arch users */
+		return _("UEFI ESP partition not detected or configured");
+	}
+
+	/* fall back for unknown types */
+	return fwupd_plugin_flag_to_string (plugin_flag);
+}
+
+static gchar *
+fu_util_plugin_flag_to_cli_text (FwupdPluginFlags plugin_flag)
+{
+	switch (plugin_flag) {
+	case FWUPD_PLUGIN_FLAG_UNKNOWN:
+	case FWUPD_PLUGIN_FLAG_CLEAR_UPDATABLE:
+	case FWUPD_PLUGIN_FLAG_USER_WARNING:
+		return NULL;
+	case FWUPD_PLUGIN_FLAG_NONE:
+		return fu_util_term_format (fu_util_plugin_flag_to_string (plugin_flag),
+					    FU_UTIL_CLI_COLOR_GREEN);
+	case FWUPD_PLUGIN_FLAG_DISABLED:
+	case FWUPD_PLUGIN_FLAG_NO_HARDWARE:
+		return fu_util_term_format (fu_util_plugin_flag_to_string (plugin_flag),
+					    FU_UTIL_CLI_COLOR_BLACK);
+	case FWUPD_PLUGIN_FLAG_LEGACY_BIOS:
+	case FWUPD_PLUGIN_FLAG_CAPSULES_UNSUPPORTED:
+	case FWUPD_PLUGIN_FLAG_UNLOCK_REQUIRED:
+	case FWUPD_PLUGIN_FLAG_EFIVAR_NOT_MOUNTED:
+	case FWUPD_PLUGIN_FLAG_ESP_NOT_FOUND:
+		return fu_util_term_format (fu_util_plugin_flag_to_string (plugin_flag),
+					    FU_UTIL_TERM_COLOR_RED);
+	default:
+		break;
+	}
+
+	/* fall back for unknown types */
+	return g_strdup (fwupd_plugin_flag_to_string (plugin_flag));
+}
+
+gchar *
+fu_util_plugin_to_string (FwupdPlugin *plugin, guint idt)
+{
+	GString *str = g_string_new (NULL);
+	const gchar *hdr;
+	guint64 flags = fwupd_plugin_get_flags (plugin);
+
+	fu_common_string_append_kv (str, idt, fwupd_plugin_get_name (plugin), NULL);
+
+	/* TRANSLATORS: description of plugin state, e.g. disabled */
+	hdr = _("Flags");
+	if (flags == 0x0) {
+		const gchar *tmp = fu_util_plugin_flag_to_cli_text (flags);
+		g_autofree gchar *li = g_strdup_printf ("• %s", tmp);
+		fu_common_string_append_kv (str, idt + 1, hdr, li);
+	} else {
+		for (guint i = 0; i < 64; i++) {
+			g_autofree gchar *li = NULL;
+			g_autofree gchar *tmp = NULL;
+			if ((flags & ((guint64) 1 << i)) == 0)
+				continue;
+			tmp = fu_util_plugin_flag_to_cli_text ((guint64) 1 << i);
+			if (tmp == NULL)
+				continue;
+			li = g_strdup_printf ("• %s", tmp);
+			fu_common_string_append_kv (str, idt + 1, hdr, li);
+
+			/* clear header */
+			hdr = "";
+		}
+	}
+
+	return g_string_free (str, FALSE);
+}
+
 static const gchar *
 fu_util_license_to_string (const gchar *license)
 {
diff --git a/src/fu-util-common.h b/src/fu-util-common.h
index 67ca691394..955c03f401 100644
--- a/src/fu-util-common.h
+++ b/src/fu-util-common.h
@@ -32,8 +32,21 @@ typedef enum {
 	FU_SECURITY_ATTR_TO_STRING_FLAG_LAST
 } FuSecurityAttrToStringFlags;
 
+typedef enum {
+	FU_UTIL_CLI_COLOR_BLACK		= 30,
+	FU_UTIL_TERM_COLOR_RED		= 31,
+	FU_UTIL_CLI_COLOR_GREEN		= 32,
+	FU_UTIL_CLI_COLOR_YELLOW	= 33,
+	FU_UTIL_CLI_COLOR_BLUE		= 34,
+	FU_UTIL_CLI_COLOR_MAGENTA	= 35,
+	FU_UTIL_CLI_COLOR_CYAN		= 36,
+	FU_UTIL_CLI_COLOR_WHITE		= 37,
+} FuUtilTermColor;
+
 void		 fu_util_print_data		(const gchar	*title,
 						 const gchar	*msg);
+gchar		*fu_util_term_format		(const gchar	*text,
+						 FuUtilTermColor fg_color);
 guint		 fu_util_prompt_for_number	(guint		 maxnum);
 gboolean	 fu_util_prompt_for_boolean	(gboolean	 def);
 
@@ -80,6 +93,9 @@ gchar		*fu_util_time_to_str		(guint64	 tmp);
 
 gchar		*fu_util_device_to_string	(FwupdDevice	*dev,
 						 guint		 idt);
+gchar		*fu_util_plugin_to_string	(FwupdPlugin	*plugin,
+						 guint		 idt);
+const gchar	*fu_util_plugin_flag_to_string	(FwupdPluginFlags plugin_flag);
 gchar		*fu_util_release_to_string	(FwupdRelease	*rel,
 						 guint		 idt);
 gchar		*fu_util_remote_to_string	(FwupdRemote *remote,
diff --git a/src/fu-util.c b/src/fu-util.c
index 50d868eb1f..1b3df7ecae 100644
--- a/src/fu-util.c
+++ b/src/fu-util.c
@@ -554,6 +554,31 @@ fu_util_get_devices (FuUtilPrivate *priv, gchar **values, GError **error)
 	return TRUE;
 }
 
+static gboolean
+fu_util_get_plugins (FuUtilPrivate *priv, gchar **values, GError **error)
+{
+	g_autoptr(GPtrArray) plugins = NULL;
+
+	/* get results from daemon */
+	plugins = fwupd_client_get_plugins (priv->client, NULL, error);
+	if (plugins == NULL)
+		return FALSE;
+
+	/* print */
+	for (guint i = 0; i < plugins->len; i++) {
+		FuPlugin *plugin = g_ptr_array_index (plugins, i);
+		g_autofree gchar *str = fu_util_plugin_to_string (FWUPD_PLUGIN (plugin), 0);
+		g_print ("%s\n", str);
+	}
+	if (plugins->len == 0) {
+		/* TRANSLATORS: nothing found */
+		g_print ("%s\n", _("No plugins found"));
+	}
+
+	/* success */
+	return TRUE;
+}
+
 static gchar *
 fu_util_download_if_required (FuUtilPrivate *priv, const gchar *perhapsfn, GError **error)
 {
@@ -2657,6 +2682,44 @@ fu_util_get_blocked_firmware (FuUtilPrivate *priv, gchar **values, GError **erro
 	return TRUE;
 }
 
+static void
+fu_util_show_plugin_warnings (FuUtilPrivate *priv)
+{
+	FwupdPluginFlags flags = FWUPD_PLUGIN_FLAG_NONE;
+	g_autoptr(GPtrArray) plugins = NULL;
+
+	/* get plugins from daemon, ignoring if the daemon is too old */
+	plugins = fwupd_client_get_plugins (priv->client, NULL, NULL);
+	if (plugins == NULL)
+		return;
+
+	/* get a superset so we do not show the same message more than once */
+	for (guint i = 0; i < plugins->len; i++) {
+		FwupdPlugin *plugin = g_ptr_array_index (plugins, i);
+		if (!fwupd_plugin_has_flag (plugin, FWUPD_PLUGIN_FLAG_USER_WARNING))
+			continue;
+		flags |= fwupd_plugin_get_flags (plugin);
+	}
+
+	/* never show these, they're way too generic */
+	flags &= ~FWUPD_PLUGIN_FLAG_DISABLED;
+	flags &= ~FWUPD_PLUGIN_FLAG_NO_HARDWARE;
+
+	/* print */
+	for (guint i = 0; i < 64; i++) {
+		const gchar *tmp;
+		g_autofree gchar *fmt = NULL;
+		if ((flags & ((guint64) 1 << i)) == 0)
+			continue;
+		tmp = fu_util_plugin_flag_to_string ((guint64) 1 << i);
+		if (tmp == NULL)
+			continue;
+		/* TRANSLATORS: this is a prefix on the console */
+		fmt = fu_util_term_format (_("WARNING:"), FU_UTIL_TERM_COLOR_RED);
+		g_printerr ("%s %s\n", fmt, tmp);
+	}
+}
+
 int
 main (int argc, char *argv[])
 {
@@ -2939,6 +3002,12 @@ main (int argc, char *argv[])
 		     /* TRANSLATORS: command description */
 		     _("Gets the list of blocked firmware."),
 		     fu_util_get_blocked_firmware);
+	fu_util_cmd_array_add (cmd_array,
+		     "get-plugins",
+		     NULL,
+		     /* TRANSLATORS: command description */
+		     _("Get all enabled plugins registered with the system"),
+		     fu_util_get_plugins);
 
 	/* do stuff on ctrl+c */
 	priv->cancellable = g_cancellable_new ();
@@ -2973,10 +3042,13 @@ main (int argc, char *argv[])
 
 	/* allow disabling SSL strict mode for broken corporate proxies */
 	if (priv->disable_ssl_strict) {
+		g_autofree gchar *fmt = NULL;
+		/* TRANSLATORS: this is a prefix on the console */
+		fmt = fu_util_term_format (_("WARNING:"), FU_UTIL_TERM_COLOR_RED);
 		/* TRANSLATORS: try to help */
-		g_printerr ("%s\n", _("WARNING: Ignoring SSL strict checks, "
-				      "to do this automatically in the future "
-				      "export DISABLE_SSL_STRICT in your environment"));
+		g_printerr ("%s %s\n", fmt, _("Ignoring SSL strict checks, "
+					      "to do this automatically in the future "
+					      "export DISABLE_SSL_STRICT in your environment"));
 		g_setenv ("DISABLE_SSL_STRICT", "1", TRUE);
 	}
 
@@ -3066,9 +3138,18 @@ main (int argc, char *argv[])
 		return EXIT_FAILURE;
 	}
 	if (fwupd_client_get_tainted (priv->client)) {
-		g_printerr ("WARNING: The daemon has loaded 3rd party code and "
-			    "is no longer supported by the upstream developers!\n");
-	}
+		g_autofree gchar *fmt = NULL;
+		/* TRANSLATORS: this is a prefix on the console */
+		fmt = fu_util_term_format (_("WARNING:"), FU_UTIL_TERM_COLOR_RED);
+		g_printerr ("%s %s\n",
+			    fmt,
+			    /* TRANSLATORS: the user is SOL for support... */
+			    _("The daemon has loaded 3rd party code and "
+			      "is no longer supported by the upstream developers!"));
+	}
+
+	/* show user-visible warnings from the plugins */
+	fu_util_show_plugin_warnings (priv);
 
 	/* we know the runtime daemon version now */
 	fwupd_client_set_user_agent_for_package (priv->client, "fwupdmgr", PACKAGE_VERSION);
diff --git a/src/org.freedesktop.fwupd.xml b/src/org.freedesktop.fwupd.xml
index 6b0f7448eb..77b708b4ca 100644
--- a/src/org.freedesktop.fwupd.xml
+++ b/src/org.freedesktop.fwupd.xml
@@ -117,6 +117,24 @@
       </arg>
     </method>
 
+    <!--***********************************************************-->
+    <method name='GetPlugins'>
+      <doc:doc>
+        <doc:description>
+          <doc:para>
+            Gets a list of all the plugins being used by the daemon.
+          </doc:para>
+        </doc:description>
+      </doc:doc>
+      <arg type='aa{sv}' name='plugins' direction='out'>
+        <doc:doc>
+          <doc:summary>
+            <doc:para>An array of plugins, with any properties set on each.</doc:para>
+          </doc:summary>
+        </doc:doc>
+      </arg>
+    </method>
+
     <!--***********************************************************-->
     <method name='GetReleases'>
       <doc:doc>
